
' maxide.bmx - blitzmax native integrated development environment

' by simonarmstrong@blitzbasic.com

' released under the Blitz Shared Source Code License 2005
' released into the public domain 2006

' requires MaxGui modules to run

'v130.1
' Hacked by David De Candia and Brucey to work with wxMax builds on OS X via bah.appstub and univeral and cross-compiling with a custom bmk.
'
' v130
' attempt to fix refresh problem when restoring project folders
' fixed crash when using CloseAll()
' fixed memory leak when switching between open source code
' fixed command line requester events
' tweaked HighlightLine() so that it doesn't highlight any trailing Chr(10) or Chr(13).

' v129
' swapped out splitter for improved MaxGUI.ProxyGadgets version (user splitter position and flip settings are reset)
' added HighlightLine() method to avoid highlighting preceeding white space when debugging
' fixed disabled step controls when encountering a second DebugStop after resuming execution
' fixed another "New Project" bug
' swapped out awkward four fingered hotkey combination for "Close Other Tabs"
' added hotkey handling code for requester Cut, Copy and Paste operations

' v128
' added "Close Other Tabs" to file menu, and fixed new project bug
' REQUIRES MAXGUI v1.19 OR HIGHER AND COMPATIBLE MAXGUI DRIVER (AVAILABLE VIA SVN)
' tweaked debugger handling for improved stability/performance
' added new StripWhitespace() method to TSearchRequester for showing shorter tooltips
' inherited window hiding focus fix from the Windows MaxGUI driver
' added call to RefreshToolbar() immediately after a process has completed and after continuing program execution
' added Ctrl+P keyboard shortcut for printing
' fixed text-area background color picker not responding when clicked
' new font options for navbar/output (now reads settings from the "navi_style" line in INI file to bump user settings)
' whoops, tool windows are *definitely* now children to the main window

' v127
' tweaked project manager to fix deselection when "Move Up" or "Move Down" was pressed
' most requester events now test for EventID() so mouse events are ignored in GTK module
' finished off the find-in-files tool someone started (really useful)
' requester dialog boxes are now tool windows and children to the main window to fix focusing issues
' tweaked requester layout so that they look neater
' dragbar is now a panel not a canvas

' v126
' changed highlighter to include . as token terminator
' changed output to send 13/10 at end of win32 line inputs
' stopped code view parse on non bmx files
' fixed endrem on lastline overrun

' v125
' fixed overrun in autoindent under cocoa
' new sort option for code nodes and expanded data
' new system hotkeys override option (alt arrow tabbing in win32)
' new menu actions for file nodes including refresh, browse and shell
' new subversion support started for project version control
' added event filter before activerequester.poll to remove unrecognized gtkmaxgui events

' v124
' fixed debugger writing to terminated process

' v123
' inherited realpath fix for win32 lan paths

' v122
' added fix for unblock aligned indenting undo
' actively remove chr(0) sent to output panel
' added FILETYPE_FILE check to opencode.create

' v121
' stopped reset of scroll position when tabbing
' refixed navbar view indexing
' fixed commands.txt parser breaking on OR char - findlast("|")
' added external help option for linux users
' open help and projects nodes on startup
' add doc modules option to program menu and fixed syncmods so no restart required
' fixed wrong window activation ugliness in TRequester.Hide
' fixed TDebugTree.SetStack synchronization bug
' added autobackup code to SaveSource method 
' fixed autoindent bug including tabs to the right of the cursor

' v120
' Ripped out isupdate stuff
' About requester now shows runtime BCC version

' v118
' Added file filter to SaveAs requester
' Edit method of TOpenCode now activates cursor and refreshes status
' TQuickHelp tokenizer now uses faster TToken map 
' ReadSource and WriteSource now use unicode LoadText and SaveText commands

' v112b
' added .doc file type to filters list
' added trycatch for bmxpath not found
' prepends bmx filenames loaded from help with "." to protect original source
' fixed unblanced quotes in wordatpos() stuffing up quick help 
' fixed exception when debugging function pointer values

' v112
' isupgrade - version check on ini file for ranlibdir and quick build disable
' debug step tools now respect cancontinue flag
' tidied up debug stdio buffers and flushing of process pipes
' linux defaults for closedocument-CtrlW nextdoc-AltRight prevdoc-AltLeft 
' end of lines converted to chr(13)+chr(10) for all saved source files 
' ReplaceAll uses locktextarea for speedup
' added print option for helppage
' filtering tab key in opencode for original block in/outdent
' removed vertical tabs from source
' added .bbdoc filetype to filters$
' fixed null href help tree entries (index node)
' new textareafilter code for the Ouput console emulator
' refreshes pointer in splitter on EVENT_MOUSEMOVE

' v111
' fixed open locked file not found at startup crash
' buildandrun continues from debugstop else kills task and rebuilds
' fixed bug on freshly loaded source being dirty
' fixed bug with options cancel
' MacOS specific hotkey bindings updated
' added .m to file FILTERS$
' adjusted GOTO and IDEOptions requesters

' v110
' DebugSource now calls ShowGadget on IDE window to bring debugger to front

' v109
' fixed WordAtPos to include underscore

' v108
' windows release version

' v107
' activate current panel when window receives focus
' fixed multiple lock build file bug
' fixed command highlighting for functions with # and ! return types
' sourcefile already open check now case insensitive
' block indent outdent now ctrl-[ and ctrl-]
' commandline args fixed

' v106b
' new defaults
' fixed replace all garbage
' removed extra endrem highlight

' v106
' added demo version support
' fixed delete / backspace undo redo issues
' added syntaxhighlight disable option
' fixed block indent / outdent highlighting issue
' added flushmem to replaceall loop
' set window title to full path of current document
' fixed double highlight for endrem

' v105c
' code view now includes labels etc. on first line
' textarea activated when panel open
' autohide output on exit now always returns to last active panel
' optimized code change algorithm
' like compiler, rem and endrem must be first code on line
' fixed up linux line spacing, font selection and code tree / create panel crashes
' new linux help system, style setting and popup menu support
 
' v105b
' added tabbing support in dialogs
' fixed pollsystem event debacle
' fixed lineselection out of view
' fixed highlighting for pasting code blocks
' fixed treeview memory leak and speedissues
' uses -x switch from bmk for build and run option
' debugging now opens source when stepping in

' v105
' activating window selects current panel
' fixed closing output window causing crash
' frees gadgets
' dirty flags now clears only if source=file and undobuffer=empty
' tidied up console window madness
' fixed gcc error check hang
' fixed label detection in code view
' fixed debugger crash with local block variable decls
' fixed codenode refresh with saveas

' v104
' fixed debug tree update and debugreset
' fixed incorrect navbar size for maximized window 
' added \ option
' notify gcc compiler errors in output

' v103
' navbar options left/right 
' added copy paste menu for output window
' added font color options for output and navbar windows
' fixed win32 paste from clipboard to use plain ascii
' stdio debugger handler
' save currentpanel, cursorpositions
' replace default "~\" requestfile path with a currentpath
' fixed pipe handling problem in quickhelp

' v102
' specify openfile from commandline 
' hides main window till all files openned
' checks window bounds against desktop size
' added deferred capitalizing cludge
' fixed rem/endrem updating problem
' fixed highlight / redraw noise
' drag&drop file support added
' dropdown menu in textarea added
' run with commandline arguments
' block indent/outdent
' fixed drag&drop text crash
' added escape handler to output window, removed autohide

' for the free community edition please visit http://sourceforge.net/projects/blitzmax-ide/

Strict

Framework maxgui.drivers
Import MaxGUI.ProxyGadgets

?Win32
Import "maxicons.o"
?

'Import bah.gtkmaxgui
'Import bah.gtkwebgtkhtml
'Import bah.gtkwebmozilla

Import brl.eventqueue
Import brl.standardio
Import brl.retro
Import brl.filesystem
Import brl.system
Import pub.freeprocess
Import brl.pngloader
Import brl.timer
Import brl.maxutil

Incbin "icons.PNG"
Incbin "splash.png"

Incbin "syncmodsblurb.txt"

AppTitle = "MaxIDE"

Const IDE_VERSION$="1.30"
Global BCC_VERSION$="{unknown}"	'not valid until codeplay opened

Const EOL$="~n"
Const SPLITWIDTH=4

Const ABOUT$=..
"{bcc_version} - Copyright Blitz Research Ltd.~n~n"+..
"Please visit www.blitzbasic.com for all your Blitz related needs!"

Const ABOUTDEMO$=..
"This demo features both the core BlitzMax package and optional MaxGUI module.~n~n"+..
"Please note that the MaxGUI module must be purchased separately."

'Const FILTERS$="Code Files:bmx,bbdoc,txt,vp,doc,plist,bb,cpp,c,m,cxx,s,fs,vs,p,fp,glsl,h,hpp,html,htm,css,js,bat;All Files:*"
'Const NodeFileTypes$="|bmx|bbdoc|cpp|cxx|c|m|h|s|fs|vs|p|fp|glsl|txt|html|js|css|java|bat|ini|jpg|png|bmp|tga|wav|pl|doc|plist|"

Const FileTypes$="bmx,bbdoc,txt,doc,plist,bb,cpp,c,m,cxx,s,glsl,hlsl,lua,py,h,hpp,html,htm,css,js,bat,mm"
Const FileTypeFilters$="Code files:"+FileTypes$+";All files:*"

Global MODOPTIONS$[]=["BRL","MAXGUI","PUB","AXE"]		',"MAK","GMAN","BIRDIE"]
Global MODINFO$[]=["BlitzMax Core Modules","MaxGUI Modules","Public Domain Core Modules","User Contributed Modules"]	'"Mark Sibly's Module Collection","Simon Armstrong's Module Collection","Garrit Grandberg's Module Collection","Dave Bird's Module Collection"]

Const HOMEPAGE$="/docs/html/index.html"

?MacOS
Global SVNCMD$="/usr/local/bin/svn"
Const LABELOFF=2
?Win32
Global SVNCMD$="svn"
Const LABELOFF=4
?Linux
Global SVNCMD$="/usr/bin/svn"
Const LABELOFF=0
?

Const MENUNEW=1
Const MENUOPEN=2
Const MENUCLOSE=3
Const MENUSAVE=4
Const MENUSAVEAS=5
Const MENUSAVEALL=6
Const MENUPRINT=7
Const MENUQUIT=8

Const MENUUNDO=9
Const MENUREDO=10
Const MENUCUT=11
Const MENUCOPY=12
Const MENUPASTE=13
Const MENUSELECTALL=14
Const MENUGOTO=15
Const MENUINDENT=16
Const MENUOUTDENT=17
Const MENUFIND=18
Const MENUFINDNEXT=19
Const MENUREPLACE=20
Const MENUNEXT=21
Const MENUPREV=22
Const MENUBUILD=23
Const MENURUN=24

Const MENUSTEP=25
Const MENUSTEPIN=26
Const MENUSTEPOUT=27
Const MENUSTOP=28

Const MENULOCKBUILD=29
Const MENUUNLOCKBUILD=30
Const MENUBUILDMODULES=31
Const MENUBUILDALLMODULES=32

Const MENUQUICKENABLED=33
Const MENUDEBUGENABLED=34
Const MENUGUIENABLED=35

Const MENUCOMMANDLINE=36
Const MENUSYNCMODS=37
Const MENUIMPORTBB=38
Const MENUFINDINFILES=39
Const MENUPROJECTMANAGER=40
Const MENUSHOWCONSOLE=41
Const MENUOPTIONS=42

Const MENUHOME=43
Const MENUBACK=44
Const MENUFORWARD=45
Const MENUQUICKHELP=46
Const MENUABOUT=47

Const MENUNEWVIEW=48
Const MENUDOCMODS=49

Const MENUTRIGGERDOCMODS=50
Const MENUTRIGGERSYNCDOCS=51

Const MENUCLOSEALL=53

Const MENUREFRESH=54
Const MENUBROWSE=55
Const MENUSHELL=56
Const MENUPROPS=57

Const MENUUPDATE=58
Const MENUCOMMIT=59

Const MENUCLOSEOTHERS=60

Const MENUTHREADEDENABLED=61

'	MENU ITEM TRIGGERING wx_MAX BUILD for Brucey's WX WIDGETS port
Const MENUBUILD_WX=98
Const MENURUN_WX=99

Const MENUUNIVERSALENABLED=100
Const MENUTARGET=200
Const MENUTARGETMACENABLED=201
Const MENUTARGETWINENABLED=202
Const MENUTARGETLINENABLED=203

Const MENURECENT=256

Const TAB$=Chr(9)
Const QUOTES$=Chr(34)

Global TEMPCOUNT
Global is_demo
Global codeplay:TCodePlay

Function CheckDemo()
	If Not is_demo Return 1
	Notify "This feature is unavailable in the demo version of BlitzMax"
	Return 0
End Function

codeplay=New TCodePlay
codeplay.Initialize

While codeplay.running
	codeplay.poll
Wend

End

Function Quote$(a$)		'add quotes to arg if spaces found
	Local	p
	If a.length=0 Return
	If a[0]=34 Return a	'already quoted
	p=a.find(" ")
	If p=-1 Return a	'no spaces
	Return Chr(34)+a+Chr(34)		
End Function

Type TToken
	Field token$
	Field help$
	Field ref$	
	Method Create:TToken(t$,h$,r$)
		token=t
		help=h
		ref=r
		Return Self
	End Method
End Type

Type TQuickHelp
	Field map:TMap=New TMap	'key=lower(token) value=token:TToken
		
	Method AddCommand:TQuickHelp(t$,l$,a$)
		map.Insert Lower(t$),New TToken.Create(t$,l$,a$)
	End Method
	
	Method Token$(cmd$)
		Local t:TToken
		t=TToken(map.ValueForKey(cmd.toLower()))
		If t Return t.token
	End Method
	
	Method Help$(cmd$)
		Local t:TToken
		t=TToken(map.ValueForKey(cmd.toLower()))
		If t Return t.help
	End Method
	
	Method Link$(cmd$)
		Local t:TToken
		t=TToken(map.ValueForKey(cmd.toLower()))
		If t Return t.ref
	End Method
	
	Function LoadCommandsTxt:TQuickHelp(bmxpath$)
		Local	text$
		Local	qh:TQuickHelp
		Local	l$,c$,p,q
		Local	token$,help$,anchor$
		Try
			text=LoadText(bmxpath+"/docs/html/Modules/commands.txt")
		Catch exception:Object
			Return Null
		EndTry
		If Not text Return Null
		qh=New TQuickHelp
		For Local l$ = EachIn text.Split("~n")
			Local i
			For i=0 Until l.length
				Local c=l[i]
				If c=Asc("_") Continue
				If c>=Asc("0") And c<=Asc("9") Continue
				If c>=Asc("a") And c<=Asc("z") Continue
				If c>=Asc("A") And c<=Asc("Z") Continue
				Exit
			Next
			token$=l[..i]
			help$=""
			anchor$=""
			q=l.findlast("|")
			If q
				help=l[..q]
				anchor=l[q+1..]
			EndIf			
			qh.AddCommand token,help,anchor
		Next
		Return qh
	End Function
End Type

Const TOOLSHOW=1
Const TOOLREFRESH=2
Const TOOLNEW=3
Const TOOLOPEN=4
Const TOOLCLOSE=5
Const TOOLSAVE=6
Const TOOLHELP=7
Const TOOLUNDO=8
Const TOOLREDO=9
Const TOOLCUT=10
Const TOOLCOPY=11
Const TOOLPASTE=12
Const TOOLQUICKSAVE=13
Const TOOLSAVEAS=14
Const TOOLGOTO=15
Const TOOLFIND=16
Const TOOLFINDNEXT=17
Const TOOLREPLACE=18
Const TOOLBUILD=19
Const TOOLRUN=20
Const TOOLLOCK=21
Const TOOLUNLOCK=22
Const TOOLSELECT=23
Const TOOLSELECTALL=24
Const TOOLINDENT=25
Const TOOLOUTDENT=26
Const TOOLACTIVATE=27
Const TOOLNAVIGATE=28
Const TOOLNEWVIEW=29
Const TOOLMENU=30
Const TOOLPRINT=31
Const TOOLERROR=32
Const TOOLOUTPUT=32
Const TOOLBUILD_WX=33
Const TOOLRUN_WX=34

Type TTool
	Method Invoke(command,argument:Object=Null)
	End Method
End Type

Type TRequester
	
	Const STYLE_OK% = 1, STYLE_CANCEL% = 2
	Const STYLE_DIVIDER% = 4, STYLE_STATUS% = 8
	Const STYLE_RESIZABLE% = 16, STYLE_STDBORDER% = 32

	Field	host:TCodePlay
	Field	window:TGadget,ok:TGadget,cancel:TGadget,divider:TGadget
	Field	centered

	Method initrequester(owner:TCodeplay,label$,w=260,h=60,flags=STYLE_OK|STYLE_CANCEL|STYLE_DIVIDER,oktext$="OK")
		
		host=owner
		
		If (flags & (STYLE_CANCEL|STYLE_OK)) Then h:+32;If (flags&STYLE_DIVIDER) Then h:+12
		
		Local windowflags% = WINDOW_TITLEBAR|WINDOW_HIDDEN|WINDOW_CLIENTCOORDS
		If (flags & STYLE_STATUS) Then windowflags:|WINDOW_STATUS
		If (flags & STYLE_RESIZABLE) Then windowflags:|WINDOW_RESIZABLE
		If Not (flags & STYLE_STDBORDER) Then windowflags:|WINDOW_TOOL
		
		window=CreateWindow(label,0,0,w,h,host.window,windowflags)
		
		If (flags & STYLE_RESIZABLE) Then windowflags:|WINDOW_RESIZABLE;SetMinWindowSize(window,w,h)
		
		If (flags & STYLE_OK) Then
			ok=CreateButton(oktext,ClientWidth(window)-101,ClientHeight(window)-32,95,26,window,BUTTON_OK);SetGadgetLayout(ok,EDGE_CENTERED,EDGE_ALIGNED,EDGE_CENTERED,EDGE_ALIGNED)
			If (flags & STYLE_CANCEL) Then
				cancel=CreateButton("Cancel",6,ClientHeight(window)-32,95,26,window,BUTTON_CANCEL);SetGadgetLayout(cancel,EDGE_ALIGNED,EDGE_CENTERED,EDGE_CENTERED,EDGE_ALIGNED)
			EndIf
		Else
			If (flags & STYLE_CANCEL) Then
				cancel=CreateButton("Close",ClientWidth(window)-101,ClientHeight(window)-32,95,26,window,BUTTON_CANCEL);SetGadgetLayout(cancel,EDGE_CENTERED,EDGE_ALIGNED,EDGE_CENTERED,EDGE_ALIGNED)
			EndIf
		EndIf
		
		If (flags & STYLE_DIVIDER) And (flags & (STYLE_OK|STYLE_CANCEL)) Then
			divider = CreateLabel( "", 6, ClientHeight(window)-42, ClientWidth(window)-12, 4, window, LABEL_SEPARATOR )
			SetGadgetLayout(divider,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_CENTERED,EDGE_ALIGNED)
		EndIf
	
	End Method
	
	Method Show()
		Local	x,y,w,h,win:TGadget
		DisableGadget host.window
		If Not centered
			win=host.window		
			w=GadgetWidth(window)
			h=GadgetHeight(window)
			x=GadgetX(win)+(GadgetWidth(win)-w)/2
			y=GadgetY(win)+(GadgetHeight(win)-h)/2
			SetGadgetShape window,x,y,w,h
			centered=True
		EndIf
		ShowGadget window
		ActivateGadget window
		host.SetRequester Self
		PollSystem
	End Method
	
	Method Hide()
		EnableGadget host.window
		HideGadget window
		host.SetRequester Null
'		host.SelectPanel host.currentpanel
	End Method

	Method Poll()
	End Method
End Type

Type TProgressRequester Extends TRequester
	Field	message$,value
	Field	showing
	Field	label:TGadget
	Field	progbar:TGadget
	
	Method Show()	'returns false if cancelled
		showing=True
		Super.Show
	End Method
	
	Method Hide()
		showing=False
		Super.Hide()
	End Method
	
	Method Open(title$)
		SetGadgetText window,title
		Show
	End Method
	
	Method Update(msg$,val)
		If msg$<>message
			message=msg
			If label FreeGadget label
			label=CreateLabel(message,8,8,260,20,window)
		EndIf
		If showing And (val&$fc)<>(value&$fc)	'only update every 4 percent
			UpdateProgBar( progbar,val/100.0 )
			PollSystem
		EndIf
		value=val
	End Method
	
	Function Create:TProgressRequester(host:TCodePlay)
		Local	progress:TProgressRequester
		progress=New TProgressRequester
		progress.initrequester(host,"ProgressRequester",280,128,STYLE_CANCEL)
		progress.progbar=CreateProgBar( 8,32,260,20,progress.window )
		Return progress
	End Function
End Type

Type TPanelRequester Extends TRequester
	Field	tabber:TGadget
	Field	panels:TGadget[]
	Field	index
	
	Method InitPanelRequester(owner:TCodeplay,label$,w=280,h=128)		
		InitRequester owner,label,w,h,STYLE_OK|STYLE_CANCEL|STYLE_STDBORDER
		tabber=CreateTabber(6,6,w-12,h-12,window)
		SetGadgetLayout tabber,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED
	End Method

	Method SetPanelIndex(i)
		HideGadget panels[index]
		index=i
		ShowGadget panels[index]
		SelectGadgetItem tabber,index	
	End Method
	
	Method SetPanel(panel:TGadget)
		Local	p:TGadget,i
		For p=EachIn panels
			If p=panel SetPanelIndex i;Exit
			i:+1
		Next
	End Method
	
	Method AddPanel:TGadget(name$)
		Local	panel:TGadget
		panel=CreatePanel(0,0,ClientWidth(tabber),ClientHeight(tabber),tabber)
		SetGadgetLayout panel,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED
		HideGadget panel
		AddGadgetItem tabber,name
		panels=panels[..panels.length+1]
		panels[panels.length-1]=panel
		Return panel
	End Method
	
	Method RemovePanel(panel)
	End Method
	
End Type

Type TCmdLineRequester Extends TRequester
	Field	label:TGadget,textfield:TGadget

	Method Poll()
		Select EventSource()
			Case window
				If EventID()=EVENT_WINDOWCLOSE
					Hide
				EndIf
			Case ok
				If EventID()=EVENT_GADGETACTION
					host.SetCommandLine TextFieldText(textfield)
					Hide
				EndIf			
			Case cancel
				If EventID()=EVENT_GADGETACTION
					SetGadgetText textfield,host.GetCommandLine()
					Hide
				EndIf
		End Select
	End Method
	
	Method Show()
		SetGadgetText textfield,host.GetCommandLine()
		Super.Show()
		ActivateGadget textfield
	End Method

	Function Create:TCmdLineRequester(host:TCodePlay)
		Local	cmd:TCmdLineRequester
		cmd=New TCmdLineRequester
		cmd.initrequester(host,"Program Command Line")
		cmd.label=CreateLabel("Program command line:",6,8,260,20,cmd.window)
		cmd.textfield=CreateTextField(6,30,ClientWidth(cmd.window)-12,21,cmd.window)
		Return cmd
	End Function
End Type

Type TGotoRequester Extends TRequester
	Field	linenumber:TGadget

	Method Show()
		Super.Show()
		ActivateGadget linenumber
	End Method

	Method Poll()
		Local	line,data
		Select EventSource()
			Case window
				If EventID()=EVENT_WINDOWCLOSE
					Hide
				EndIf
			Case ok
				line=Int(TextFieldText(linenumber))
				Hide
				host.activepanel.Invoke TOOLGOTO,String(line)
			Case cancel
				Hide
		End Select
	End Method

	Function Create:TGotoRequester(host:TCodePlay)
		Local	seek:TGotoRequester
		seek=New TGotoRequester
		seek.initrequester(host,"Goto Line",260,66,STYLE_OK|STYLE_CANCEL|STYLE_DIVIDER,"Goto")
		CreateLabel("Line Number:",6,8+4,114,20,seek.window)
		seek.linenumber=CreateTextField(150,8,ClientWidth(seek.window)-(150+6),21,seek.window)
		Return seek
	End Function
End Type

Type TColor
	Field	red,green,blue

	Method Set(rgb)
		red=(rgb Shr 16)&255
		green=(rgb Shr 8)&255
		blue=rgb&255
	End Method

	Method ToString$()
		Return ""+red+","+green+","+blue
	End Method

	Method FromString(s$)
		Local	p,q
		p=s.Find(",")+1
		If Not p Return
		q=s.Find(",",p)+1
		If Not q Return
		red=Int(s[..p-1])
		green=Int(s[p..q-1])
		blue=Int(s[q..])
	End Method

	Method Request()
		If RequestColor(red,green,blue)
			red=RequestedRed()
			green=RequestedGreen()
			blue=RequestedBlue()
			Return True
		EndIf				
	End Method	
End Type

Type TTextStyle

	Field	label:TGadget,panel:TGadget,combo:TGadget
	Field	underline:TGadget, color:TColor
	Field	flags
	
	Method Set(rgb,bolditalic)
		color.set(rgb)
		flags=bolditalic
	End Method

	Method Format(textarea:TGadget,pos,length)
		FormatTextAreaText textarea,color.red,color.green,color.blue,flags,pos,length
	End Method

	Method ToString$()
		Return ""+color.red+","+color.green+","+color.blue+","+flags
	End Method

	Method FromString(s$)
		Local	p,q,r
		p=s.Find(",")+1;If Not p Return
		q=s.Find(",",p)+1;If Not q Return
		r=s.Find(",",q)+1;If Not r Return
		color.red=Int(s[..p-1])
		color.green=Int(s[p..q-1])
		color.blue=Int(s[q..r-1])
		flags=Int(s[r..])
	End Method

	Method Poll()
		Select EventSource()
			Case panel
				If EventID()=EVENT_MOUSEDOWN
					Return color.Request()
				EndIf
			Case combo
				flags=(flags&~3)|SelectedGadgetItem(combo)
				Return True
			Case underline
				If EventData() Then flags:|TEXTFORMAT_UNDERLINE Else flags:&~TEXTFORMAT_UNDERLINE
				Return True
		End Select
	End Method
	
	Method Refresh()
		SetPanelColor panel,color.red,color.green,color.blue
		SelectGadgetItem combo,flags&3
		SetButtonState(underline,(flags&TEXTFORMAT_UNDERLINE <> 0))
	End Method

	Function Create:TTextStyle(name$,xpos,ypos,window:TGadget)
		Local	s:TTextStyle
		s=New TTextStyle
		s.color=New TColor
		s.label=CreateLabel(name,xpos,ypos+4,80,24,window)
		s.panel=CreatePanel(xpos+84,ypos,24,24,window,PANEL_BORDER|PANEL_ACTIVE)
		SetPanelColor s.panel,255,255,0
		s.combo=CreateComboBox(xpos+112,ypos,96,24,window)
		s.underline=CreateButton("Underline",xpos+216,ypos,ClientWidth(window)-(xpos+220),24,window,BUTTON_CHECKBOX)
		AddGadgetItem s.combo,"Normal"
		AddGadgetItem s.combo,"Bold"
		AddGadgetItem s.combo,"Italic"
		AddGadgetItem s.combo,"Bold + Italic"
		Return s
	End Function
End Type

Type TGadgetStyle
	
	Global fntLibrary:TGUIFont[] =	[TGuiFont(Null), LookupGuiFont(GUIFONT_SYSTEM), LookupGuiFont(GUIFONT_MONOSPACED), ..
							LookupGuiFont(GUIFONT_SANSSERIF), LookupGuiFont(GUIFONT_SERIF), ..
							LookupGuiFont(GUIFONT_SCRIPT) ]

	Field	label:TGadget,fpanel:TGadget,bpanel:TGadget,fcombo:TGadget,fbutton:TGadget
	Field	font_name$, font_size:Double
	Field	fg:TColor, bg:TColor
	Field	font_type = GUIFONT_SYSTEM, font:TGUIFont = fntLibrary[font_type]

	Method Apply(gadget:TGadget)
		SetGadgetFont gadget,font
		SetGadgetColor gadget,bg.red,bg.green,bg.blue,True
		SetGadgetColor gadget,fg.red,fg.green,fg.blue,False
	End Method
	
	Method Set(fg_rgb,bg_rgb,ftype,fname$="",fsize=0)
		fg.set(fg_rgb)
		bg.set(bg_rgb)
		If Not fntLibrary[ftype] Then
			font_name=fname
			font_size=fsize
		Else
			font_name=FontName(fntLibrary[ftype])
			font_size=FontSize(fntLibrary[ftype])
		EndIf
		font_type=ftype
	End Method

	Method ToString$()
		Return font_name+","+font_size+","+fg.ToString()+","+bg.ToString()+","+font_type
	End Method
	
	Function GetArg$(a$ Var)
		Local 	p,r$
		p=a.Find(",")+1
		If p=0 p=Len a$+1
		r$=a$[..p-1]
		a$=a$[p..]
		Return r$	
	End Function
	
	Method FromString(s$)		
		font_name=GetArg(s$)
		font_size=Double(GetArg(s$))
		fg.red=Int(GetArg(s$))
		fg.green=Int(GetArg(s$))
		fg.blue=Int(GetArg(s$))
		bg.red=Int(GetArg(s$))
		bg.green=Int(GetArg(s$))
		bg.blue=Int(GetArg(s$))
		font_type=Int(GetArg(s$))
		If fntLibrary[font_type] Then
			font_name=FontName(fntLibrary[font_type])
			font_size=FontSize(fntLibrary[font_type])
		EndIf
	End Method

	Method Poll()
		Local	f:TGUIFont
		Select EventSource()
			Case fpanel
				If EventID()=EVENT_MOUSEDOWN
					Return fg.Request()
				EndIf
			Case bpanel
				If EventID()=EVENT_MOUSEDOWN
					Return bg.Request()
				EndIf
			Case fcombo, fbutton
				If EventSource() = fcombo Then
					If Not (EventData() < 0) Then
						font_type = EventData()
						f = fntLibrary[font_type]
					EndIf
				Else
					font_type = 0
					SelectGadgetItem fcombo, font_type
				EndIf
				If Not f Then f=RequestFont(font)
				If f
					font_name=FontName(f)
					font_size=FontSize(f)
					Return True
				EndIf				
		End Select
	End Method
	
	Method Refresh()
		font=fntLibrary[font_type]
		If Not font Then font=LoadGuiFont(font_name,font_size)
		SetPanelColor fpanel,fg.red,fg.green,fg.blue
		SetPanelColor bpanel,bg.red,bg.green,bg.blue
		SelectGadgetItem fcombo, font_type
		Local tmpFloatText$[] = String(font_size).Split(".")
		If tmpFloatText.length > 1 Then tmpFloatText[1] = tmpFloatText[1][..Min(2,tmpFloatText[1].length)]
		SetGadgetText fbutton,font_name+" : "+".".Join(tmpFloatText)+"pt"
	End Method

	Function Create:TGadgetStyle(name$,xpos,ypos,window:TGadget)
		Local	s:TGadgetStyle
		s=New TGadgetStyle
		s.fg=New TColor
		s.bg=New TColor
		s.label=CreateLabel(name,xpos,ypos+4,56,24,window)
		s.fpanel=CreatePanel(xpos+58,ypos,24,24,window,PANEL_BORDER|PANEL_ACTIVE)
		s.bpanel=CreatePanel(xpos+86,ypos,24,24,window,PANEL_BORDER|PANEL_ACTIVE)
		s.fbutton=CreateButton("..",xpos+112,ypos+30,ClientWidth(window)-(xpos+118),24,window)
		s.fcombo=CreateComboBox(xpos+112,ypos,ClientWidth(window)-(xpos+118),24,window)
		AddGadgetItem s.fcombo, "User Defined Font", GADGETITEM_DEFAULT
		AddGadgetItem s.fcombo, "GUI Default Font"
		AddGadgetItem s.fcombo, "Monospaced Font"
		AddGadgetItem s.fcombo, "Sans Serif Font"
		AddGadgetItem s.fcombo, "Serif Font"
		AddGadgetItem s.fcombo, "Script Font"
		Return s
	End Function
End Type

Const NORMAL=0
Const COMMENT=1
Const QUOTED=2
Const KEYWORD=3

Type TOptionsRequester Extends TPanelRequester
' panels
	Field	optionspanel:TGadget,editorpanel:TGadget,toolpanel:TGadget
' settings
	Field	showtoolbar,restoreopenfiles,autocapitalize,syntaxhighlight,autobackup,autoindent,hideoutput
	Field	externalhelp,systemkeys,sortcode
	Field	tabsize
	Field	editfontname$,editfontsize,editcolor:TColor
	Field	outputfontname$,outputfontsize,outputcolor:TColor
' states
	Field	editfont:TGUIFont
' gadgets
	Field	tabbutton:TGadget
	Field	editpanel:TGadget,editbutton:TGadget
	Field	buttons:TGadget[11]
	Field	styles:TTextStyle[4]
	Field	textarea:TGadget
	Field	outputstyle:TGadgetStyle
	Field	navstyle:TGadgetStyle
	Field	dirty
	Field	undo:TBank
	
	Method Snapshot()
		If Not undo undo=CreateBank(8192)
		Local stream:TStream=CreateBankStream(undo)
		write stream
		stream.close
	End Method
	
	Method Restore()
		If Not undo Return
		Local stream:TStream=CreateBankStream(undo)
		Read stream
		stream.close
	End Method

	Method SetDefaults()
		showtoolbar=True
		restoreopenfiles=True
		autocapitalize=True
		syntaxhighlight=True
		autobackup=True
		autoindent=True
		tabsize=4
		editfontname$=FontName(TGadgetStyle.fntLibrary[GUIFONT_MONOSPACED])
		editfontsize=FontSize(TGadgetStyle.fntLibrary[GUIFONT_MONOSPACED])
		editcolor.set( $334455 )
		styles[NORMAL].set( $ffffff,0 )
		styles[COMMENT].set( $bbeeff,0 )
		styles[QUOTED].set( $00ff66,0 )
		styles[KEYWORD].set( $ffff00,0 )
		outputstyle.set(0,-1,GUIFONT_MONOSPACED)
		navstyle.set(0,-1,GUIFONT_SYSTEM)
		RefreshGadgets
	End Method

	Method Write(stream:TStream)
		Local i
		stream.WriteLine "[Options]"
		stream.WriteLine "showtoolbar="+showtoolbar
		stream.WriteLine "restoreopenfiles="+restoreopenfiles
		stream.WriteLine "autocapitalize="+autocapitalize
		stream.WriteLine "syntaxhighlight="+syntaxhighlight
		stream.WriteLine "autobackup="+autobackup		
		stream.WriteLine "autoindent="+autoindent		
		stream.WriteLine "tabsize="+tabsize
		stream.WriteLine "editfontname="+editfontname		
		stream.WriteLine "editfontsize="+editfontsize		
		stream.WriteLine "editcolor="+editcolor.ToString()		
		stream.WriteLine "normal_style="+styles[0].ToString()		
		stream.WriteLine "comment_style="+styles[1].ToString()		
		stream.WriteLine "quote_style="+styles[2].ToString()		
		stream.WriteLine "keyword_style="+styles[3].ToString()		
		stream.WriteLine "console_style="+outputstyle.ToString()	'Renamed from 'output_style' to bump users to default monospace font.
		stream.WriteLine "navi_style="+navstyle.ToString()	'Renamed from 'nav_style' to bump users to default treeview font.
		stream.WriteLine "hide_output="+hideoutput
		stream.WriteLine "external_help="+externalhelp
		stream.WriteLine "system_keys="+systemkeys
		stream.WriteLine "sort_code="+sortcode
	End Method

	Method Read(stream:TStream)
		Local	f$,p,a$,b$,t
		While Not stream.Eof()
			f$=stream.ReadLine()
			If f$="" Or (f$[..1]="[" And f$<>"[Options]") Exit
			p=f.find("=")
			a$=f[..p]
			b$=f[p+1..]
			t=Int(b)
			Select a$
				Case "showtoolbar" showtoolbar=t
				Case "restoreopenfiles" restoreopenfiles=t
				Case "autocapitalize" autocapitalize=t
				Case "syntaxhighlight" syntaxhighlight=t
				Case "autobackup" autobackup=t
				Case "autoindent" autoindent=t
				Case "tabsize" tabsize=t		
				Case "editfontname" editfontname=b
				Case "editfontsize" editfontsize=t
				Case "editcolor" editcolor.FromString(b)		
				Case "normal_style" styles[0].FromString(b)
				Case "comment_style" styles[1].FromString(b)
				Case "quote_style" styles[2].FromString(b)
				Case "keyword_style" styles[3].FromString(b)
				Case "console_style" outputstyle.FromString(b)	'Renamed from 'output_style' to bump users to default monospace font.
				Case "navi_style" navstyle.FromString(b)	'Renamed from 'nav_style' to bump users to default treeview font.
				Case "hide_output" hideoutput=t
				Case "external_help" externalhelp=t
				Case "system_keys" systemkeys=t
				Case "sort_code" sortcode=t
			End Select
		Wend		
		RefreshGadgets
	End Method
	
	Method RefreshGadgets()
		Local	i,rgb:TColor
		editfont=LoadGuiFont(editfontname,editfontsize)
		SetButtonState buttons[0],showtoolbar
		SetButtonState buttons[1],restoreopenfiles
		SetButtonState buttons[2],autocapitalize
		SetButtonState buttons[3],syntaxhighlight
		SetButtonState buttons[4],autobackup
		SetButtonState buttons[5],autoindent
		SetButtonState buttons[6],hideoutput
		SetButtonState buttons[7],externalhelp
		SetButtonState buttons[8],systemkeys
		SetButtonState buttons[9],sortcode
		SelectGadgetItem tabbutton,Min(Max(tabsize/2-1,0),7)
		SetPanelColor editpanel,editcolor.red,editcolor.green,editcolor.blue
		SetGadgetText editbutton,editfontname+" : "+editfontsize + "pt"
		For i=0 To 3
			styles[i].Refresh
		Next
		LockTextArea textarea
		SetTextAreaColor textarea,editcolor.red,editcolor.green,editcolor.blue,True
		SetGadgetFont textarea,editfont
		styles[0].format(textarea,0,-1)
		styles[1].format(textarea,0,12)
		styles[2].format(textarea,20,10)
		styles[3].format(textarea,31,5)
		UnlockTextArea textarea
		outputstyle.Refresh
		navstyle.Refresh
		dirty=True
	End Method

	Method Poll()
		Local	i,font:TGUIFont,refresh
		For i=0 To 3
			refresh=refresh|styles[i].Poll()
		Next
		refresh=refresh|outputstyle.Poll()
		refresh=refresh|navstyle.Poll()
		Select EventID()
			Case EVENT_GADGETACTION, EVENT_WINDOWCLOSE
				Select EventSource()
					Case buttons[0];showtoolbar=ButtonState(buttons[0]);dirty=True
					Case buttons[1];restoreopenfiles=ButtonState(buttons[1])
					Case buttons[2];autocapitalize=ButtonState(buttons[2]);dirty=True
					Case buttons[3];syntaxhighlight=ButtonState(buttons[3]);dirty=True
					Case buttons[4];autobackup=ButtonState(buttons[4])
					Case buttons[5];autoindent=ButtonState(buttons[5])
					Case buttons[6];hideoutput=ButtonState(buttons[6])
					Case buttons[7];externalhelp=ButtonState(buttons[7])
					Case buttons[8];systemkeys=ButtonState(buttons[8]);dirty=2
					Case buttons[9];sortcode=ButtonState(buttons[9]);dirty=3
					Case tabber;SetPanelIndex SelectedGadgetItem(tabber)
					Case ok
						Hide
						Select dirty
							Case True
								host.RefreshAll
							Case 2
								host.Restart
						End Select
						dirty=False
						SnapShot
					Case window
						If EventID()=EVENT_WINDOWCLOSE
							Restore
							dirty=False
							Hide
						EndIf
					Case cancel
						Restore
						dirty=False
						Hide
					Case tabbutton
						tabsize=(SelectedGadgetItem(tabbutton)+1)*2
						refresh=True
					Case editpanel
						If EventID()=EVENT_MOUSEDOWN
							refresh=editcolor.Request()
						EndIf
					Case editbutton
						font=RequestFont(editfont)
						If font
							editfontname=FontName(font)
							editfontsize=FontSize(font)
							refresh=True
						EndIf
				EndSelect
			Case EVENT_MOUSEDOWN
				Select EventSource()
					Case editpanel
						If EventID()=EVENT_MOUSEDOWN
							editcolor.Request()
							refresh=True
						EndIf
				EndSelect
		EndSelect
		If refresh RefreshGadgets
	End Method
	
	Method InitOptionsRequester(host:TCodePlay)		
		Local	w:TGadget
		InitPanelRequester(host,"Options",340,400)
' init values
		editcolor=New TColor
' init gadgets
		optionspanel=AddPanel("Options")
		editorpanel=AddPanel("Editor")
		toolpanel=AddPanel("Tools")

		w=optionspanel
		buttons[0]=CreateButton("Show Toolbar",6,4,ClientWidth(w)-12,26,w,BUTTON_CHECKBOX)
		buttons[1]=CreateButton("Open Files at Startup",6,30,ClientWidth(w)-12,26,w,BUTTON_CHECKBOX)
		buttons[2]=CreateButton("Auto Capitalize",6,56,ClientWidth(w)-12,26,w,BUTTON_CHECKBOX)
		buttons[3]=CreateButton("Syntax Highlighting",6,82,ClientWidth(w)-12,26,w,BUTTON_CHECKBOX)
		buttons[4]=CreateButton("Auto Backup",6,108,ClientWidth(w)-12,26,w,BUTTON_CHECKBOX)
		buttons[5]=CreateButton("Auto Indent",6,134,ClientWidth(w)-12,26,w,BUTTON_CHECKBOX)
		buttons[6]=CreateButton("Hide Output When Process Complete",6,160,ClientWidth(w)-12,26,w,BUTTON_CHECKBOX)
		buttons[7]=CreateButton("Use External Help Browser",6,186,ClientWidth(w)-12,26,w,BUTTON_CHECKBOX)
		buttons[8]=CreateButton("Use OS Specific Shortcut Keys",6,212,ClientWidth(w)-12,26,w,BUTTON_CHECKBOX)
		buttons[9]=CreateButton("Sort Nodes in Code View",6,238,ClientWidth(w)-12,26,w,BUTTON_CHECKBOX)

		w=editorpanel
		CreateLabel("Background:",6,6+4,80,24,w)
		editpanel=CreatePanel(90,6,24,24,w,PANEL_BORDER|PANEL_ACTIVE)
		editbutton=CreateButton("..",118,6,ClientWidth(w)-124,24,w)
		
		tabbutton=CreateComboBox(118,36,ClientWidth(w)-124,24,w)
		For Local i=1 To 8
			AddGadgetItem tabbutton,"TabSize: "+(i*2)
		Next
		
		styles=New TTextStyle[4]
		styles[0]=TTextStyle.Create("Plain Text:",6,66,w)
		styles[1]=TTextStyle.Create("Remarks:",6,96,w)
		styles[2]=TTextStyle.Create("Strings:",6,126,w)
		styles[3]=TTextStyle.Create("Keywords:",6,156,w)
		
		textarea=CreateTextArea(6,220,ClientWidth(w)-12,ClientHeight(w)-226,w,TEXTAREA_READONLY)
		SetTextAreaText textarea,"'Sample Code~n~nname$=~qBlitzMax~q~nPrint name$~n"

		w=toolpanel
		outputstyle=TGadgetStyle.Create("Output: ",6,6,w)
		navstyle=TGadgetStyle.Create("Navbar: ",6,66,w)

		SetDefaults()
		SetPanel optionspanel
		
		SnapShot
	End Method
	
	Function Create:TOptionsRequester(host:TCodePlay)
		Local	o:TOptionsRequester
		o=New TOptionsRequester
		o.InitOptionsRequester host
		Return o
	End Function
	
End Type

Type TFindRequester Extends TRequester
	Field	findterm:TGadget
	
	Method ShowFind(term$="")
		If term SetGadgetText(findterm,term)
		Super.Show()
		ActivateGadget findterm
	End Method

	Method Poll()
		Local	find$,data		
		Select EventSource()
			Case window
				If EventID()=EVENT_WINDOWCLOSE
					Hide
				EndIf				
			Case ok
				If EventID() = EVENT_GADGETACTION
					find=TextFieldText(findterm)
					Hide
					PollSystem
					host.activepanel.Invoke TOOLFINDNEXT,find
				EndIf
			Case cancel
				If EventID() = EVENT_GADGETACTION Then Hide
		End Select
	End Method

	Function Create:TFindRequester(host:TCodePlay)
		Local	seek:TFindRequester
		seek=New TFindRequester
		seek.initrequester(host,"Find",280,66,STYLE_OK|STYLE_CANCEL|STYLE_DIVIDER,"Find")
		CreateLabel("Find:",6,12,82,24,seek.window)
		seek.findterm=CreateTextField(88,8,ClientWidth(seek.window)-(88+6),21,seek.window)
		Return seek
	End Function
End Type

Type TReplaceRequester Extends TRequester
	Field	findterm:TGadget,replaceterm:TGadget
	Field	findnext:TGadget,replaceit:TGadget,replaceall:TGadget
	
	Method Show()
		Super.Show()
		ActivateGadget findterm
	End Method

	Method Poll()
		Local	find$,Replace$
		Select EventSource()
			Case window
				If EventID()=EVENT_WINDOWCLOSE
					Hide
				EndIf
			Case cancel
				If EventID() = EVENT_GADGETACTION Then Hide
			Case ok
				If EventID() = EVENT_GADGETACTION Then
					find=TextFieldText(findterm)
					host.activepanel.Invoke TOOLFINDNEXT,find
				EndIf
			Case replaceit
				If EventID() = EVENT_GADGETACTION Then
					Replace=TextFieldText(replaceterm)
					If host.activepanel.Invoke(TOOLREPLACE,Replace)
						host.activepanel.Invoke TOOLFINDNEXT,find
					EndIf
				EndIf
			Case replaceall
				If EventID() = EVENT_GADGETACTION Then
					find=TextFieldText(findterm)
					Replace=TextFieldText(replaceterm)
					host.activepanel.Invoke TOOLREPLACE,find+Chr(0)+Replace
				EndIf
		End Select
	End Method

	Function Create:TReplaceRequester(host:TCodePlay)
		Local x,y
		Local	seek:TReplaceRequester
		seek=New TReplaceRequester
		seek.initrequester(host,"Find and Replace",380,80,STYLE_OK|STYLE_CANCEL|STYLE_DIVIDER,"Find Next")
		
		y=11
		CreateLabel( "Find:",6,y+4,88,24,seek.window )
		seek.findterm=CreateTextField( 96,y,168,21,seek.window )

		y:+32		
		CreateLabel( "Replace With:",6,y+4,88,24,seek.window )
		seek.replaceterm=CreateTextField( 96,y,168,21,seek.window )

		x=ClientWidth(seek.window)-102
		y=8
		seek.replaceit=CreateButton("Replace",x,y,96,26,seek.window)
		seek.replaceall=CreateButton("Replace All",x,y+32,96,26,seek.window)
		
		Return seek
	End Function
End Type

Type TSyncModsRequester Extends TRequester
	Field	label:TGadget,user:TGadget,password:TGadget,proxy:TGadget
	Field	options:TGadget[]

	Method SyncMods()
		Local	u$,p$,x$,cmd$,i,n
		u$=quote(TextFieldText(user))
		p$=quote(TextFieldText(password))
		x$=TextFieldText(proxy)
		cmd$=quote(host.bmxpath+"/bin/syncmods")
		cmd$:+" -u "+u$+" -p "+p$
		If x cmd$:+" -y "+x
		n=MODOPTIONS.length
		For Local i=0 Until n
			If ButtonState(options[i]) cmd$:+" "+MODOPTIONS[i]
		Next			
		Hide
		host.execute cmd,"Synchronize Modules"',MENUTRIGGERDOCMODS
	End Method
	
	Method Poll()
		Select EventSource()
			Case window
				If EventID()=EVENT_WINDOWCLOSE
					Hide
				EndIf
			Case ok
				If EventID() = EVENT_GADGETACTION Then SyncMods
			Case cancel
				If EventID() = EVENT_GADGETACTION Then Hide
		End Select
	End Method
	
	Method Show()
		Super.Show()
		ActivateGadget user
	End Method

	Function Create:TSyncModsRequester(host:TCodePlay)
		Local	sync:TSyncModsRequester
		Local m$
		
		m$=LoadString("incbin::syncmodsblurb.txt")
		
		sync=New TSyncModsRequester
		sync.initrequester(host,"Synchronize modules",420,380,STYLE_OK|STYLE_CANCEL|STYLE_DIVIDER,"Sync")

'		sync.label=CreateLabel(m$,8,20,380,160,sync.window)
		sync.label=CreateTextArea(6,6,ClientWidth(sync.window)-12,160,sync.window,TEXTAREA_READONLY|TEXTAREA_WORDWRAP)
		SetGadgetText sync.label,m$
		
		Local i,n,y

		y=180
		
		CreateLabel("Username",20,y+4,80,24,sync.window)
		sync.user=CreateTextField(108,y,160,21,sync.window)
		y:+30

		CreateLabel("Password",20,y+4,80,24,sync.window)
		sync.password=CreateTextField(108,y,160,21,sync.window,TEXTFIELD_PASSWORD)		
		y:+30

		CreateLabel("Proxy Server",20,y+4,80,24,sync.window)
		sync.proxy=CreateTextField(108,y,160,21,sync.window)		
		y:+30
		
		n=MODOPTIONS.length
		sync.options=New TGadget[n]
		For Local i=0 Until n
			sync.options[i]=CreateButton(MODOPTIONS[i],20,y,85,24,sync.window,BUTTON_CHECKBOX)
			If i<3
				SetButtonState sync.options[i],True
				DisableGadget sync.options[i]
			EndIf
			CreateLabel MODINFO[i],108,y+4,220,24,sync.window
			y:+26
		Next
				
		Return sync
	End Function
	
	Function GetArg$(a$ Var)
		Local 	p,r$
		p=a.Find(",")+1
		If p=0 p=Len a$+1
		r$=a$[..p-1]
		a$=a$[p..]
		Return r$	
	End Function

	Function Crypt$(a$)
		Local b$,c:Byte,i
		For i=0 Until Len a
			c=a[i]
			If c>63 And c<192 c:~(i*-41)&63
			b:+Chr(c)
		Next
		Return b
	End Function
			
	Method FromString(s$)
		Local a$,i,n	
		SetGadgetText user,GetArg(s$)
		SetGadgetText password,Crypt(GetArg(s$))
		SetGadgetText proxy,GetArg(s$)
		n=MODOPTIONS.length
		While s$
			a$=GetArg(s$)
			For Local i=2 Until n
				If a$=MODOPTIONS[i] SetButtonState options[i],True
			Next
		Wend
	End Method
	
	Method ToString$()
		Local sync$,i,n
		sync=TextFieldText(user)
		sync:+","+Crypt(TextFieldText(password))
		sync:+","+TextFieldText(proxy)
		n=MODOPTIONS.length
		For Local i=2 Until n
			If ButtonState(options[i]) sync:+","+MODOPTIONS[i]
		Next
		Return sync
	End Method
End Type

Type TEventHandler Extends TTool
	Method OnEvent() Abstract
End Type

Type TToolPanel Extends TEventHandler
	Field	name$,path$
	Field	panel:TGadget
	Field	index
	Field	active
	
	Method Show()
	End Method
End Type

Type TView
	Field	node:TGadget
	Field	state
End Type

Type TNode Extends TTool
	Const	HIDESTATE=0
	Const	CLOSEDSTATE=1
	Const	OPENSTATE=2

	Field	name$,sortname$
	Field	parent:TNode
	Field	kids:TList=New TList
	Field	views:TView[]
' activate program	
	Field	target:TTool
	Field	action
	Field	argument:Object

	Method SortKids( ascending=True )
		Local term:TLink=kids._head
		Repeat
			Local link:TLink=kids._head._succ
			Local sorted=True
			Repeat
				Local succ:TLink=link._succ
				If succ=term Exit
				Local cc=TNode(link._value).sortname.Compare( TNode(succ._value).sortname )
				If (cc>0 And ascending) Or (cc<0 And Not ascending)
					Local link_pred:TLink=link._pred
					Local succ_succ:TLink=succ._succ
					link_pred._succ=succ
					succ._succ=link
					succ._pred=link_pred
					link._succ=succ_succ
					link._pred=succ
					succ_succ._pred=link
					sorted=False
				Else
					link=succ
				EndIf
			Forever
			If sorted Return
			term=link
		Forever
	End Method

	Method FindArgument:TNode(arg:Object)
		Local	n:TNode,r:TNode,a$
		If arg.Compare(argument)=0 Return Self
		a$=(String(arg)).ToLower()
		If a And a=(String(argument)).toLower() Return Self
		For n=EachIn kids
			r=n.FindArgument(arg)
			If r Return r
		Next
	End Method
	
	Method Dump(indent$="")
		Local	n:TNode		
		Print indent+name
		indent:+"~t"
		For n=EachIn kids
			n.Dump indent
		Next
	End Method		
	
	Method IsHidden()
		Local	v:TView
		If Not parent Return False
		For v=EachIn parent.views
			If v.state=OPENSTATE Return False
		Next
		Return True
	End Method
	
	Method SetAction(tool:TTool,cmd,arg:Object=Null)
		target=tool
		action=cmd
		argument=arg
	End Method

	Method Hide(v:TView=Null)	'null means hide in all views
		Local	n:TNode
		For n=EachIn kids
			n.hide v
		Next
		If v
			If v.node FreeTreeViewNode v.node;v.node=Null
		Else
			For v=EachIn views
				If v.node FreeTreeViewNode v.node;v.node=Null
			Next
		EndIf
	End Method
	
	Method Detach()
		Hide()
		If parent parent.kids.remove Self;parent=Null
	End Method
	
	Method FreeKids()
		For Local n:TNode = EachIn kids
			n.free
		Next
	End Method
	
	Method Free()
		FreeKids()
		Detach()
		target=Null;argument=Null;views=Null
	End Method
	
	Method Invoke(command,arg:Object=Null)
		Select command
		Case TOOLACTIVATE 
			If target Return target.Invoke(action,argument)
		End Select
	End Method
	
	Method Find:TNode(treeviewnode:TGadget,view=0)
		Local	n:TNode,r:TNode
		Local	v:TView
		v=getview(view)
		If v And v.node=treeviewnode Return Self
		For n=EachIn kids
			r=n.Find(treeviewnode,view)
			If r Return r
		Next
	End Method
	
	Method SetNode(treeviewnode:TGadget,view=0)
		Local	v:TView
		v=getview(view)
		v.node=treeviewnode
		open view
	End Method
	
	Method HighLight(view=-1)
		Local	v:TView
		If view=-1
			For view=0 Until views.length
				HighLight view
			Next
			Return
		EndIf
		v=GetView(view)
		If v.node SelectTreeViewNode v.node
	End Method
	
	Method Open(view=-1)
		Local	v:TView
		If view=-1
			For view=0 Until views.length
				Open view
			Next
			Return
		EndIf
		v=GetView(view)
		If v.state<>OPENSTATE
			v.state=OPENSTATE
			RefreshView view
'			If v.node ExpandTreeViewNode v.node
		EndIf
	End Method
	
	Method Close(view=0)
		Local	v:TView
		v=GetView(view)
		If v.state<>CLOSEDSTATE
			v.state=CLOSEDSTATE
'			If v.node CollapseTreeViewNode v.node
		EndIf
	End Method
	
	Method GetState(view=0)
		Local v:TView
		v=GetView(view)
		Return v.state
	End Method

	Method GetView:TView(view=0)
		If view>=views.length 
			views=views[..view+1]
		EndIf
		If views[view]=Null views[view]=New TView
		Return views[view]
	End Method
	
	Method GetIndex()
		Local	node:TNode
		Local	i		
		If parent
			For node=EachIn parent.kids
				If node=Self Return i
				i:+1
			Next
		EndIf
	End Method
	
	Method Refresh()
		For Local i% = 0 Until views.length
			RefreshView i
		Next
	End Method
	
	Method RefreshView(view=0)
		Local	n:TNode,quick,nodeToOpen:TGadget
		Local	v:TView,vv:TView
		Local	node
		If parent And parent.getstate(view)=CLOSEDSTATE quick=True		
		v=getview(view)
		If v.node And parent
			If GadgetText(v.node) <> name Then ModifyTreeViewNode v.node,name
			If v.state=OPENSTATE nodeToOpen = v.node;quick = False
		Else
			If parent And name
				vv=parent.getview(view)
				If vv.node
					v.node=InsertTreeViewNode(GetIndex(),name,vv.node)
					If v.state=HIDESTATE v.state=CLOSEDSTATE					
					If vv.state=OPENSTATE nodeToOpen = vv.node
					quick=False
				EndIf
			EndIf
		EndIf
		If quick Return
		If Not kids Return
		For n=EachIn kids
			n.RefreshView view
		Next
		If nodeToOpen Then ExpandTreeViewNode nodeToOpen
	End Method

	Method NodeAfter:TNode(node:TNode)
		Local	link:TLink
		If node	link=kids.FindLink(node)
		If link link=link.NextLink()
		If link Return TNode(link.Value())	
	End Method

	Method Sync(snap:TNode)
		Local	snapkid:TNode
		Local	currentkid:TNode
		Local	kid:TNode
		Local	t:TNode
		Local	link:TLink

		If snap.name<>name Return
		If kids.Count() currentkid=TNode(kids.First())
		For snapkid=EachIn snap.kids
' if same name in list 
			kid=currentkid
			While kid
				If kid.name=snapkid.name Exit
				kid=NodeAfter(kid)
			Wend
' then remove entries in front			
			If kid
				While currentkid<>kid
					t=currentkid
					currentkid=NodeAfter(currentkid)			
					t.free()
				Wend
			EndIf
' if same name sync else insert 
			If currentkid And currentkid.name=snapkid.name	'merge values if same name 
				currentkid.Sync snapkid
				currentkid=NodeAfter(currentkid)
			Else
				snapkid.detach
				If currentkid
					link=kids.FindLink(currentkid)
					kids.InsertBeforeLink snapkid,link
				Else
					kids.AddLast snapkid
				EndIf
				snapkid.parent=Self
			EndIf
		Next
' remove any entries at end
		While currentkid
			t=currentkid
			currentkid=NodeAfter(currentkid)			
			t.free()
		Wend
		Refresh()
	End Method

	Method SetName(n$)
		name=n
	End Method
		
	Method AddNode:TNode(name$)
		Local	v:TNode
		v=New TNode
		v.setname name
		Append v
		Return v
	End Method
	
	Method Append(v:TNode)
		v.parent=Self
		kids.AddLast v
	End Method	
	
	Function CreateNode:TNode(name$)
		Local	node:TNode
		node=New TNode
		node.setname name
		Return node
	End Function		
End Type

Type THelpPanel Extends TToolPanel

	Field host:TCodePlay
	Field htmlview:TGadget

	Method AddLink:TNode(parent:TNode,name$,href$)
		Local	n:TNode
		If parent 
			n=parent.AddNode(name)
		Else
			n=host.helproot
		EndIf
		If href href=RealPath(href)
		n.SetAction(Self,TOOLNAVIGATE,href)
		Return n
	End Method

	Method ImportLinks( node:TNode,path$ )

		Local t$=path+"/index.html"
		If FileType( t )<>FILETYPE_FILE Return

		node=AddLink( node,StripDir( path ),t )

		Local map:TMap=New TMap
		
		'scan for html files
		For Local e$=EachIn LoadDir( path )
			If e="index.html" Continue
			Local p$=path+"/"+e
			Select FileType( p )
			Case FILETYPE_DIR
				ImportLinks node,p
			Case FILETYPE_FILE
				If Not e.StartsWith( "_" ) And ExtractExt( e ).Tolower()="html"
					map.Insert StripExt( e ),p
				EndIf
			End Select
		Next

		'scan for anchors in index.html...
		'
		'note: anchors must be quote enclosed and of simple form <a name="blah">
		Local c$=LoadText( t ),i
		Repeat
			i=c.Find( "<a name=~q",i )
			If i=-1 Exit
			i:+9
			Local i2=c.Find( "~q>",i )
			If i2=-1 Exit
			Local q$=c[i..i2]
			If q.StartsWith( "_" ) Continue
			map.Insert q,t+"#"+q
			i=i2+1
		Forever

		For Local kv:TKeyValue=EachIn map
			AddLink node,String( kv.Key() ),String( kv.Value() )
		Next

	End Method

	Method SyncDocs()
		host.helproot.FreeKids

		ImportLinks Null,host.bmxpath+"/docs/html"

		Local link:TNode
		For Local m$=EachIn EnumModules()
			If m.StartsWith( "brl." ) Or m.StartsWith( "pub." ) Or m.StartsWith("maxgui.") Continue
			Local p$=ModulePath( m )+"/doc/commands.html"
			If FileType( p )<>FILETYPE_FILE Continue
			If Not link link=AddLink( host.helproot,"Third party modules","" )
			AddLink link,m,p
		Next

		link=AddLink( host.helproot,"Index","" )
		
		If FileType( host.bmxpath+"/docs/html/Modules/commands.txt" )=FILETYPE_FILE
			Local comm$=LoadText( host.bmxpath+"/docs/html/Modules/commands.txt" )
			For Local line$=EachIn comm.Split( "~n" )
				Local bits$[]=line.Split( "|" )
				If bits.length<>2 Continue
				Local i=bits[0].Find( " : " )
				If i<>-1 bits[0]=bits[0][..i]
				AddLink link,bits[0],host.bmxpath+bits[1]
			Next
		EndIf
			
		host.helproot.Refresh
	End Method

	Method Invoke(command,argument:Object=Null)
		Local	href$
		If Not htmlview Return
		Select command
			Case TOOLCUT
				GadgetCut htmlview
			Case TOOLCOPY
				GadgetCopy htmlview
			Case TOOLPASTE
				GadgetPaste htmlview
			Case TOOLSHOW 
				ActivateGadget htmlview	
				host.SetTitle
			Case TOOLNAVIGATE
				href$=String(argument)
				If href Go href
			Case TOOLPRINT
				GadgetPrint htmlview
		End Select
	End Method

	Method OnEvent()
		Local	url$,p,t$
		If EventSource()=htmlview
			Select EventID()			
				Case EVENT_GADGETACTION				'NAVIGATEREQUEST
					url$=String( EventExtra() )
					If url[..5]="http:"
						OpenURL url
					Else
						p=url.findlast(".")
						If p>-1
							t$=url[p..].tolower()
							If t$=".bmx"
								If url.Find( "file://" )=0
									url=url[7..]
									?Win32
									url=url[1..]
									?
								EndIf 
								url=url.Replace("%20"," ")
								Local source:TOpenCode=host.OpenSource(url)
								If source source.MakePathTemp
							Else 
								url=url.Replace("\","/")
								url=url.Replace("user/index","user/welcome")
								url=url.Replace("lang/index","lang/welcome")
								url=url.Replace("mods/index","mods/welcome")
								Go url$
							EndIf
						EndIf
					EndIf
			End Select			
		EndIf
	End Method
	
	Method Go(url$,internal=False)
		Local	node:TNode

		If host.options.externalhelp And Not internal
			PollSystem
			OpenURL url
			MinimizeWindow host.window
			PollSystem
			Return
		EndIf

		HtmlViewGo htmlview,url
		host.SelectPanel Self
		node=host.helproot.FindArgument(RealPath(url))
		If node
			node.Highlight
		Else
'			print "node not found"
		EndIf		
		ActivateGadget htmlview			
	End Method
	
	Method Home()
		Go host.bmxpath+HOMEPAGE,True
	End Method
	
	Method Forward()
		HtmlViewForward htmlview
	End Method

	Method Back()
		HtmlViewBack htmlview
	End Method

	Function Create:THelpPanel(host:TCodePlay)
		Local	p:THelpPanel
		Local	root,style		
		p=New THelpPanel
		p.host=host
		p.name="Help"
		codeplay.addpanel(p)
		style=HTMLVIEW_NONAVIGATE		'HTMLVIEW_NOCONTEXTMENU
		p.htmlview=CreateHTMLView(0,0,ClientWidth(p.panel),ClientHeight(p.panel),p.panel,style)		
		SetGadgetLayout p.htmlview,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED
'		p.Home
		p.SyncDocs
		Return p
	End Function

End Type

Type TSearchResult
	
	Field filepath$
	Field char%, line%
	Field linestring$
	
	Method AddToListbox( pGadget:TGadget )
		AddGadgetItem pGadget, "[" + line + ", " + char + "] " + filepath, 0, -1, StripWhitespace(linestring,char), Self
	EndMethod
	
	Method Set:TSearchResult(pFilePath$,pChar%,pLine%,pLineString$)
		filepath = pFilePath
		char = pChar
		line = pLine
		linestring = pLineString
		Return Self
	EndMethod
	
	Function StripWhitespace$(pString$,pChar%)
		If pString.length < pChar Then Return pString
		Local i%, outString$
		For i = 0 Until pString.length
			Select pString[i..i+1]
				Case " ", "~t","~n","~r"
					If outString And outString[outString.length-1..] <> " " Then outString:+" "
				Default;outString:+pString[i..i+1]
			EndSelect
		Next
		Return outString
	EndFunction
	
EndType

Type TSearchRequester Extends TRequester
	
	Const strSearchText$ = "Search", strStopSearchText$ = "Stop Search"
	
	Field	findbox:TGadget,typebox:TGadget,pathbox:TGadget,pathbutton:TGadget,pathsubdir:TGadget,results:TGadget
	Field lstSearchResults:TList = New TList
	
	Field strFileExts$[][] = [["bmx"],filetypes.Split(","),String[](Null)]
	
	Field safetyCount% = -1, safetyThreshold = 500, safetyResetCount% = 0
	
	Method Poll()
		Local	id,data,index
		id=EventID()
		data=EventData()
		Select EventSource()
			Case results
				Select id
					Case EVENT_GADGETACTION
						Local tmpSearchResult:TSearchResult = TSearchResult(EventExtra())
						If tmpSearchResult Then
							host.DebugSource( tmpSearchResult.filepath, tmpSearchResult.line, tmpSearchResult.char )
							Hide()
						EndIf
				EndSelect
			Case pathbutton
				If EventID()=EVENT_GADGETACTION
					Local tmpString$ = RequestDir( "Search files in folder...",GadgetText(pathbox))
					If tmpString Then SetGadgetText(pathbox,tmpString)
				EndIf
			Case window
				If EventID()=EVENT_WINDOWCLOSE Then Hide()
			Case findbox
				If EventID() = EVENT_GADGETACTION Then 
					If GadgetText(findbox) Then EnableGadget(ok) Else DisableGadget(ok)
				EndIf
			Case ok
				If EventID()=EVENT_GADGETACTION
					If safetyCount < 0 Then StartSearch() Else safetyCount = -2
				EndIf
			Case cancel
				If EventID()=EVENT_GADGETACTION Then Hide()
		End Select
	End Method
	
	Method Hide()
		safetyCount = -2
		Super.Hide()
	EndMethod
	
	Method ShowWithPath( pPath$ )
		If pPath Then SetGadgetText( pathbox, pPath )
		Show()
		ActivateGadget( findbox )
	EndMethod
	
	Method StartSearch()
		
		PollSystem()
		
		Select FileType(RealPath(GadgetText(pathbox)))
			Case 0;Notify "The path specified doesn't exist!",True;ActivateGadget(pathbox);Return
			Case 1;Notify "The path entered is for a file, please enter the path of a directory.",True;ActivateGadget(pathbox);Return
		EndSelect
		
		If Not GadgetText(findbox) Then
			Notify "You must enter a search string to find!",True;ActivateGadget(findbox);Return
		EndIf
		
		safetyResetCount = 0;safetyCount = 0
		SetGadgetText ok, strStopSearchText;ClearGadgetItems results
		SearchPath( GadgetText(pathbox), strFileExts[SelectedGadgetItem(typebox)], GadgetText(findbox).ToLower(), ButtonState(pathsubdir) )
		SetGadgetText ok, strSearchText;safetyCount = -1
		SetStatusText window, "Search complete! Found " + CountGadgetItems(results) + " instances!"
		
	EndMethod
	
	Method SearchPath(pPath$,pFileType$[],pString$,pRecurse% = True)
		
		pPath$ = RealPath(pPath)						'Make sure we are using a real path
		
		Local tmpSearchDir$[] = LoadDir(pPath,True)			'Load directors contents into string array
		If Not tmpSearchDir Then Return					'Return if the directory is invalid
		tmpSearchDir.Sort()							'Sort the contents alphabetically
		
		SetStatusText window, "Searching: " + pPath$			'And let user know which directory is being searched
		
		For Local tmpItem$ = EachIn tmpSearchDir
			
			Local tmpFullPath$ = pPath + "/" + tmpItem
			
			Select FileType(tmpFullPath)
				Case 0;Continue						'Skip item if, for whatever reason, it doesn't exist
				Case 1							'If file, then check extension and search if valid
					If Not pFileType
						SearchFile(tmpFullPath,pString)
					Else
						Local tmpExt$ = ExtractExt(tmpFullPath).ToLower$()
						For Local tmpValidExt$ = EachIn pFileType
							If tmpExt = tmpValidExt Then SearchFile(tmpFullPath,pString)
						Next
					EndIf
				Case 2							'If folder, then we might have to search recursively 
					If pRecurse Then SearchPath(tmpFullPath,pFileType,pString,pRecurse)
			EndSelect
			
			If Not ShouldContinue() Then Return
			
		Next
		
		PollSystem();If PeekEvent() Then host.Poll()			'Let the system update as we could be searching a while
		
	EndMethod
	
	Method SearchFile(pPath$,pString$)
		Local tmpText$ = LoadText( pPath ), tmpLines$[], tmpFindPos%, tmpCharCount%, tmpLineNo%
		Local tmpStringLength% = pString.length, tmpChunkLines$[], tmpPrevLines$
		
		If tmpText Then
			tmpLines = tmpText.Split("~n")
			tmpText = tmpText.ToLower()
			tmpFindPos = tmpText.Find(pString)
			While ShouldContinue() And tmpFindPos > -1
				tmpChunkLines = tmpText[..tmpFindPos].Split("~n")
				tmpPrevLines = "~n".Join(tmpChunkLines[..tmpChunkLines.length-1])
				tmpLineNo:+(tmpChunkLines.length)-1
				Local tmpSearchResult:TSearchResult = New TSearchResult.Set(pPath,tmpFindPos-tmpPrevLines.length,tmpLineNo+1,tmpLines[tmpLineNo])
				tmpSearchResult.AddToListbox(results);safetyCount:+1
				tmpCharCount:+tmpFindPos+tmpStringLength
				tmpText = tmpText[tmpFindPos+tmpStringLength..]
				tmpFindPos = tmpText.Find(pString)
			Wend
		EndIf
	EndMethod
	
	Method ShouldContinue()
		If safetyCount < 0 Then Return False
		If safetyCount >= safetyThreshold Then
			If Confirm( "There have been " + ((safetyResetCount*safetyThreshold)+safetyCount) +  " instances found.~n~nWould you like to continue?" ) Then safetyCount = 0;safetyResetCount:+1 Else safetyCount = -1;Return False
		EndIf
		Return True
	EndMethod
	
	Function Create:TSearchRequester(host:TCodePlay)
		Local	search:TSearchRequester
		search=New TSearchRequester
		search.initrequester(host,"Find In Files",440,280,STYLE_CANCEL|STYLE_DIVIDER|STYLE_OK|STYLE_STATUS|STYLE_RESIZABLE,"Search")
		DisableGadget(search.ok)
		
		SetGadgetLayout(CreateLabel("Find:",6,8+4,80,24,search.window),EDGE_ALIGNED,EDGE_CENTERED,EDGE_ALIGNED,EDGE_CENTERED)
		search.findbox=CreateTextField(88,8,ClientWidth(search.window)-(88+6),21,search.window);SetGadgetLayout(search.findbox,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_CENTERED)
		
		
		SetGadgetLayout(CreateLabel("File Types:",6,42,80,24,search.window),EDGE_ALIGNED,EDGE_CENTERED,EDGE_ALIGNED,EDGE_CENTERED)
		search.typebox=CreateComboBox(88,38,ClientWidth(search.window)-(88+6),24,search.window);SetGadgetLayout(search.typebox,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_CENTERED)
		
		AddGadgetItem( search.typebox, "BlitzMax Files",GADGETITEM_DEFAULT,-1,"*.bmx" )
		AddGadgetItem( search.typebox, "Code Files",0,-1,fileTypes )
		AddGadgetItem( search.typebox, "All Files (Warning: Includes Binary Files)",0,-1,"*")
		
		SetGadgetLayout(CreateLabel("Search Path:",6,72,80,24,search.window),1,0,1,0)
		search.pathbox=CreateTextField(88,68,ClientWidth(search.window)-(88+6+30+6),21,search.window);SetGadgetLayout(search.pathbox,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_CENTERED)
		search.pathbutton=CreateButton("..",ClientWidth(search.window)-(34+6),65,34,26,search.window);SetGadgetLayout(search.pathbutton,EDGE_CENTERED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_CENTERED)
		SetGadgetText(search.pathbox, CurrentDir())
		
		search.pathsubdir=CreateButton("Search sub-directories",88,98,ClientWidth(search.window)-(88+6),20,search.window,BUTTON_CHECKBOX);SetGadgetLayout(search.pathsubdir,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_CENTERED)
		SetButtonState(search.pathsubdir,True)
		
		search.results=CreateListBox(6,128,ClientWidth(search.window)-12,280-(128+6),search.window);SetGadgetLayout(search.results,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED)
		
		Return search
	End Function
End Type


Type TProjectRequester Extends TRequester
	Field	projects:TProjects
	Field	listbox:TGadget
	Field	add:TGadget
	Field	remove:TGadget
	Field	props:TGadget
	Field	moveup:TGadget
	Field	movedown:TGadget
	Field	Current:TProjectFolderNode

	Method Invoke(command,arg:Object=Null)
		Select command
		Case TOOLACTIVATE 
			Refresh
		End Select
	End Method
	
	Method SetCurrent(i)
		If i=-1 
			DisableGadget remove
			DisableGadget moveup
			DisableGadget movedown
			DisableGadget props 
			Current=Null
		Else
			Current=TProjectFolderNode(GadgetItemExtra(listbox,i))
			If Current 
				EnableGadget remove
				EnableGadget props 
				EnableGadget moveup
				EnableGadget movedown
			EndIf
		EndIf
	End Method

	Method Poll()
		Local	index
		'id=EventID()
		'data=EventData()
		Select EventSource()
			Case window
				If EventID()=EVENT_WINDOWCLOSE Then Hide()
			Case add
				If EventID() = EVENT_GADGETACTION Then 
					projects.NewProject
					Refresh
				EndIf
			Case remove
				If EventID() = EVENT_GADGETACTION Then 
					projects.RemoveProject SelectedGadgetItem(listbox)
					Refresh
				EndIf
			Case cancel
				If EventID() = EVENT_GADGETACTION Then Hide
			Case props
				If EventID() = EVENT_GADGETACTION And Current 
					host.projectprops.Open(Current)
				EndIf
			Case listbox
				If EventID()=EVENT_GADGETSELECT
					SetCurrent SelectedGadgetItem(listbox)	'EventData()
				ElseIf EventID()=EVENT_GADGETACTION
					SetCurrent SelectedGadgetItem(listbox)
					host.projectprops.Open(Current)
				EndIf
			Case moveup
				If EventID()=EVENT_GADGETACTION Then
					index=projects.MoveProject(SelectedGadgetItem(listbox),-1)
					Refresh
					SelectGadgetItem listbox,index
					SetCurrent(index)
				EndIf
			Case movedown
				If EventID()=EVENT_GADGETACTION Then
					index=projects.MoveProject(SelectedGadgetItem(listbox),1)
					Refresh
					SelectGadgetItem listbox,index
					SetCurrent(index)
				EndIf
		End Select
	End Method

	Method Refresh()
		Local	node:TNode		
		ClearGadgetItems listbox
		For node=EachIn projects.kids
			If TFolderNode(node)'node.argument
				AddGadgetItem listbox,node.name,0,-1,"",node
			EndIf
		Next
		SetCurrent -1
	End Method
	
	Method Open(projnode:TProjects)
		projects=projnode
		Refresh
		Show
	End Method
	
	Function Create:TProjectRequester(host:TCodePlay)
		Local x,y
		Local	proj:TProjectRequester
		proj=New TProjectRequester
	
		proj.initrequester(host,"Project Manager",400,168,STYLE_CANCEL|STYLE_DIVIDER)
		proj.listbox=CreateListBox( 6,8,244,154,proj.window )
		
		x=ClientWidth(proj.window)-144
		proj.add=CreateButton("Add Project",x,8,138,26,proj.window)
		proj.remove=CreateButton("Remove Project",x,40,138,26,proj.window)

		proj.moveup=CreateButton("Move Up",x,72,138,26,proj.window)
		proj.movedown=CreateButton("Move Down",x,104,138,26,proj.window)

		proj.props=CreateButton("Properties",x,136,138,26,proj.window)

		DisableGadget proj.remove
		DisableGadget proj.moveup
		DisableGadget proj.movedown
		DisableGadget proj.props 
		Return proj
	End Function
End Type

Type TProjectProperties Extends TRequester
	Field	proj:TProjectFolderNode
	Field	localname:TGadget
	Field	localpath:TGadget
	Field	pathbutton:TGadget
	Field	path:TGadget
	Field	user:TGadget
	Field	password:TGadget
	Field	checkout:TGadget
'	Field	update:TGadget
'	Field	commit:TGadget
	Field	poprequester:TRequester	'hack for restoring to projectmanager requester
	Field	dirty

	Method Invoke(command,arg:Object=Null)
		Select command
		Case TOOLACTIVATE 
			Refresh
		End Select
	End Method
	
	Method Tidy()
		If dirty
			proj.Set GadgetText(localname),GadgetText(localpath),GadgetText(path),GadgetText(user),GadgetText(password)
			dirty=False
		EndIf
	End Method
	
	Method Poll()
		If (EventID() <> EVENT_GADGETACTION) And (EventID() <> EVENT_WINDOWCLOSE) Then Return
		Select EventSource()
			Case localname,localpath,path,user,password
				dirty=True
			Case pathbutton
				Local dir$=RequestDir("Select the project folder")
				If dir
					If dir[dir.length-1..]="/"	'fltk hack
						dir=dir[..dir.length-1]
					EndIf
					SetGadgetText localpath,dir
					If GadgetText(localname)=""
						SetGadgetText localname,StripDir(dir)
					EndIf
					dirty=True
				EndIf				
			Case checkout
				Tidy
				Hide				
				proj.CheckoutVersion		
Rem
			Case commit
				Tidy
				Hide				
				proj.CommitVersion		
			Case update
				Tidy
				Hide				
				proj.UpdateVersion		
EndRem
			Case ok
				Tidy
				Hide				
			Case cancel
				Hide
			Case window
				If EventID()=EVENT_WINDOWCLOSE
					Hide
				EndIf
		End Select
	End Method
	
	Method Hide()
		EnableGadget host.window
		HideGadget window
		host.SetRequester Null'poprequester
		If poprequester poprequester.Show
	End Method

	Method Refresh()
		SetGadgetText localname,proj.name
		SetGadgetText localpath,proj.path
		SetGadgetText path,proj.svnpath
		SetGadgetText user,proj.svnuser
		SetGadgetText password,proj.svnpass
	End Method
	
	Method Open(projnode:TProjectFolderNode)
		proj=projnode
		poprequester=host.activerequester
		Refresh
		Show
	End Method
	
	Function Create:TProjectProperties(host:TCodePlay)
		Local	proj:TProjectProperties

		proj=New TProjectProperties
		proj.initrequester(host,"Project Properties",480,250)
		
		Local projectdetails:TGadget
		projectdetails=CreatePanel(6,8,ClientWidth(proj.window)-12,85,proj.window,PANEL_GROUP,"Project Details")
		
		Local i,n,y
		y=4

		CreateLabel("Name:",6,y+4,72,24,projectdetails)
		proj.localname=CreateTextField(88,y,ClientWidth(projectdetails)-(88+6),21,projectdetails)
'		proj.pathbutton=CreateButton("..",434,y,34,28,projectdetails)
		y:+30

		CreateLabel("Path:",8,y+4,72,24,projectdetails)
		proj.localpath=CreateTextField(88,y,ClientWidth(projectdetails)-(88+34+6+6),21,projectdetails)
		proj.pathbutton=CreateButton("..",ClientWidth(projectdetails)-(34+6),y-3,34,26,projectdetails)
		y:+30


		Local svnbox:TGadget
		svnbox=CreatePanel(6,101,ClientWidth(proj.window)-12,144,proj.window,PANEL_GROUP,"Subversion Control")
		y=4
		CreateLabel("URL:",8,y+LABELOFF,72,24,svnbox)
		proj.path=CreateTextField(88,y,ClientWidth(svnbox)-92,21,svnbox)
		y:+30
		CreateLabel("Username:",8,y+LABELOFF,72,24,svnbox)
		proj.user=CreateTextField(88,y,ClientWidth(svnbox)-92,21,svnbox)
		y:+30
		CreateLabel("Password:",8,y+LABELOFF,72,24,svnbox)
		proj.password=CreateTextField(88,y,ClientWidth(svnbox)-92,21,svnbox,TEXTFIELD_PASSWORD)		
		y:+30
		proj.checkout=CreateButton("Check Out Project",ClientWidth(svnbox)-154,ClientHeight(svnbox)-32,150,28,svnbox)
'		proj.update=CreateButton("Update Project",180,y+10,150,28,svnbox)
'		proj.commit=CreateButton("Commit Project",340,y+10,150,28,svnbox)
		y:+40

		Return proj
	End Function
End Type

Function GetInfo$(a$ Var)
	Local 	p,r$
	p=a.Find("|")+1
	If p=0 p=Len a$+1
	r$=a$[..p-1]
	a$=a$[p..]
	Return r$	
End Function

Type TFolderNode Extends TNode
'	Field	host:TCodePlay
	Field	owner:TNode
	Field	path$
	Field	scanned
	Field	version
	Field	foldertype
	
	Const PROJECTFOLDER=0
	Const DIRECTORYFOLDER=1
	Const FILEFOLDER=2

	Method FindFolderFromPath:TFolderNode(dir$)
		Local folder:TFolderNode
		Local result:TFolderNode
		If path=dir Return Self
		For folder=EachIn kids
			result=folder.FindFolderFromPath(dir)
			If result Return result
		Next
	End Method
	
	Method SetName(n$)
		If version n=n+"("+version+")"
		Super.SetName n
		Refresh
	End Method
		
	Method SetVersion(ver)
		Local n$	
		version=ver
		n=StripDir(path)
'		If version n=n+"("+version+")"
		SetName n
	End Method
	
	Method Write(stream:TStream)
		Local folder:TFolderNode
		Local isopen
		If GetState()=OPENSTATE isopen=True
		If version Or isopen
			stream.WriteLine "proj_data="+path+"|"+isopen+"|"+version+"|"
		EndIf
		For folder=EachIn kids
			folder.Write(stream)
		Next
	End Method

	Method ProjectHost:TCodePlay()
		Local n:TNode
		n=Self
		While n
			If TProjects(n) Return TProjects(n).host
			n=n.parent
		Wend
	End Method

	Method ProjectNode:TProjectFolderNode()
		Local n:TNode
		n=Self
		While n
			If TProjectFolderNode(n) Return TProjectFolderNode(n)
			n=n.parent
		Wend
	End Method

	Method RunSVN(cmd$,about$,refresh)
		Local host:TCodePlay
		Local project:TProjectFolderNode
	
		host=ProjectHost()
		If Not host Notify"node host not found";Return
		
		project=ProjectNode()
		If Not project Notify"node project not found";Return
		
		If project.svnuser 
			cmd:+" --username "+project.svnuser
			If project.svnpass cmd:+" --password "+project.svnpass
		EndIf

		If refresh
			host.execute cmd,about,MENUREFRESH,True,Self
		Else
			host.execute cmd,about,0,0,Self
		EndIf
	End Method
	
	Method UpdateVersion()
		Local cmd$
		cmd$=svncmd+" update"
		cmd:+" "+quote(path)
		RunSVN cmd,"Updating "+path,True
'		host.execute cmd,"Updating "+path,MENUREFRESH,True,Self
	End Method
	
	Method CommitVersion()
		Local cmd$
		cmd=svncmd+" commit"
		cmd:+" -m ~qmy comment~q"
		cmd:+" "+quote(path)
		RunSVN cmd,"Committing "+path,False
'		host.execute cmd,"Committing "+path
	End Method
	
	Method Open(view=-1)
		If Not scanned Then Rescan()
		Super.Open view
	End Method

	Method AddFileNode:TNode(file$)
		Local	n:TNode
		Local 	ext$	
		If (","+FileTypes+",").Find(","+ExtractExt(file).toLower()+",")<0 Return
		n=AddNode(StripDir(file))
		n.SetAction(owner,TOOLOPEN,file)
		ext=ExtractExt(file$).ToLower()
		n.sortname=ext+n.name
		Return n
	End Method

	Method AddFolderNode:TNode(path$)
		Local	n:TNode
		n=TFolderNode.CreateFolderNode(path,DIRECTORYFOLDER)
		n.sortname=" "+n.name
		Append n
		Return n
	End Method

	Method Scan(o:TNode)
		Local	flist:TList
		Local	dir,f$,p$,t	
		owner=o
		flist=New TList
		
		For f$ = EachIn LoadDir(path,True)
			If f[..1] = "." Then Continue
			p$=path+"/"+f
			Select FileType(p$)
				Case FILETYPE_FILE
					AddFileNode p$
				Case FILETYPE_DIR
					AddFolderNode p$
			End Select	
		Next
		
		SortKids
	End Method
	
	Method ScanKids()
		Local	f:TFolderNode
		If scanned Return
		For f=EachIn kids
			f.Scan owner
		Next
		scanned=True
	End Method

	Method Rescan()
		FreeKids
		Scan owner
		scanned=False
		ScanKids
		Refresh
	End Method
	
	Method Invoke(command,argument:Object=Null)
		Local host:TCodePlay
		Local cmd,p
		Local line$
	
		host=ProjectHost()
		If Not host Notify"node host not found";Return
		
		Select command
		Case TOOLOUTPUT
			line$=String(argument)
			p=line.find(" revision ")
			If p>-1
				SetVersion Int(line[p+10..])
			EndIf
'			If line[..12]="At revision "
'			DebugLog "TOOLOUTPUT:"+line
			Return
		Case TOOLERROR
			line$=String(argument)
'			DebugLog "TOOLERROR:"+line
			Return
		Case TOOLMENU
			cmd=Int(String(argument))
			Select cmd
			Case 0		'special toolmenu-command=0 fired by rightbutton node context
				Highlight			
				Local menu:TGadget
				menu=host.projects.projmenu
				PopupWindowMenu host.window,menu,Self
			Case MENUREFRESH
				Rescan
			Case MENUBROWSE
				OpenURL RealPath(path)
			Case MENUSHELL
				Local cd$=CurrentDir()
				ChangeDir RealPath(path)
?MacOS
				Local s$="/bin/bash"' --help"
				host.execute s$,"Shell Terminal"
?Linux
				Local s$="/bin/bash"' --help"
				host.execute s$,"Shell Terminal"
?Win32
				host.execute "cmd","Shell Terminal - Type Exit To End"
?
				ChangeDir cd
			Case MENUUPDATE
				UpdateVersion 
			Case MENUCOMMIT
				CommitVersion
'			Case MENUPROPS
'				host.projectprops.Open(Self)
			Case MENUFINDINFILES
				host.searchreq.ShowWithPath( RealPath(path) )
			End Select
		End Select
	End Method

	Function CreateFolderNode:TFolderNode(path$,foldertype)
		Local	n:TFolderNode
		n=New TFolderNode
'		n.host=host
		n.setname StripDir(path)
		n.path=path
		n.foldertype=foldertype
		Return n
	End Function
End Type

Type TProjectFolderNode Extends TFolderNode
	Field 	owner:TProjects
	Field	svnpath$,svnuser$,svnpass$,svnversion
	Field	svnerr$

	Method CheckoutVersion()	'to do - needs to move old version to temp?
		Local cmd$
		cmd$=svncmd+" checkout"
		cmd:+" "+quote(svnpath)
		cmd:+" "+quote(path)
		RunSVN cmd,"Checking out "+svnpath+" to "+path,True
		'host.execute cmd,"Checking out "+svnpath+" to "+path,MENUREFRESH,True,Self
	End Method

	Function Crypt$(a$)
		Local b$,c,i
		For i=0 Until Len a
			c=a[i]
			If c>31 c:~((i*-5)&31)
			b:+Chr(c&255)
		Next
		Return b
	End Function

	Method ToString$()
		Local prj$
		Local isopen
		If GetState()&OPENSTATE isopen=True
		prj=name+"|"+path+"|"+svnpath+"|"+svnuser+"|"+crypt(svnpass)+"|"+isopen+"|"+version
		Return prj
	End Method

	Method Write(stream:TStream)
		Local folder:TFolderNode
		stream.WriteLine "proj_node="+ToString()
		For folder=EachIn kids
			folder.Write(stream)
		Next
	End Method
	
	Method FromString(info$)
		Local n$
		n$=GetInfo(info)
		If n="" n="Unknown"
		setname n
		path=GetInfo(info)
		If path path=owner.host.FullPath(path)
		svnpath=GetInfo(info)
		svnuser=GetInfo(info)
		svnpass=GetInfo(info)
		Scan(owner)
		Local isopen,vers
		isopen=Int(GetInfo(info))
		If isopen
			Open
'			Rescan
'			scanned=False
		EndIf	
		vers=Int(GetInfo(info))
		If vers
			SetVersion vers
		EndIf
	End Method

	Method Invoke(command,argument:Object=Null)
		Local cmd
		Select command
		Case TOOLMENU
			cmd=Int(String(argument))
			Select cmd
			Case MENUPROPS
				Return owner.host.projectprops.Open(Self)
			End Select
		End Select
		Return Super.Invoke(command,argument)
	End Method

	Method Set(n$,p$,s$,user$,pass$)
		path=owner.host.FullPath(p)
		setname n
		svnpath=s
		svnuser=user
		svnpass=pass
		Rescan
		owner.host.projectreq.Refresh()
	End Method

	Function CreateProjectNode:TProjectFolderNode(projects:TProjects,info$)
		Local n:TProjectFolderNode
		n=New TProjectFolderNode
		n.owner=projects
		n.FromString(info)
		n.foldertype=PROJECTFOLDER
		Return n
	End Function
End Type

Type TProjects Extends TNode
	Field host:TCodePlay
	Field addproj:TNode
	Field projmenu:TGadget
	Field projmenuprops:TGadget


	Method RemoveProject(index)
		Local	node:TNode
		If index<0 Or index>=kids.Count() Return
		node=TNode(kids.ValueAtIndex(index))
		If node node.Free
		Refresh
	End Method			
	
	Method MoveProject(index,dir)
		Local node:TNode
		Local link:TLink
		If index<0 Or index>=kids.Count() Return index
		node=TNode(kids.ValueAtIndex(index))
		If node 
			addproj.Detach
			node.Hide
			link=kids.FindLink(node)
			If dir>0
				If link link=link._succ
				If link 
					kids.Remove node
					kids.InsertAfterLink node,link
					index:+1
				EndIf
			Else
				If link link=link._pred
				If link 
					kids.Remove node
					kids.InsertBeforeLink node,link			
					index:-1
				EndIf
			EndIf		
			Append addproj
			Refresh
		EndIf
		Return index
	End Method			

	Method NewProject()
		Local proj:TProjectFolderNode
		addproj.Detach
		proj=TProjectFolderNode.CreateProjectNode(Self,"New Project")
'		proj.scan(Self)
		Append proj
		Append addproj
		host.projectprops.Open(proj)
		Refresh
	End Method

	Method AddProject(data:TList)
		Local info$
		Local project:TProjectFolderNode
		Local folder:TFolderNode
		For info=EachIn data
			If Not project
				addproj.Detach
				project=TProjectFolderNode.CreateProjectNode(Self,info)
				Append project
				Append addproj
				Refresh
			Else
				Local path$
				Local popen
				Local pversion
				path=GetInfo(info)
				popen=Int(GetInfo(info))
				pversion=Int(GetInfo(info))
				folder=project.FindFolderFromPath(path)
				If folder
					folder.SetVersion pversion
					folder.ReScan()
					If popen Then folder.Open()
				EndIf		
			EndIf
		Next
	End Method

	Method Write(stream:TStream)
		Local	project:TProjectFolderNode
		For project=EachIn kids
			project.Write(stream)		
		Next
	End Method

	Method Invoke(command,argument:Object=Null)
		Select command
		Case TOOLNEW
			NewProject
		Case TOOLOPEN
			host.OpenSource String(argument)
		End Select
	End Method
			
	Function CreateProjects:TProjects(host:TCodePlay)
		Local	p:TProjects
		p=New TProjects
		p.SetName("Projects")
		p.host=host		
		p.addproj=p.AddNode("Add Project")
		p.addproj.SetAction p,TOOLNEW

		p.projmenu=CreateMenu("Proj",0,Null)
		CreateMenu "Refresh",MENUREFRESH,p.projmenu
		CreateMenu "Find in Files",MENUFINDINFILES,p.projmenu
		CreateMenu "Explore",MENUBROWSE,p.projmenu
		CreateMenu "Shell",MENUSHELL,p.projmenu
		CreateMenu "",0,p.projmenu
		CreateMenu "Update Version",MENUUPDATE,p.projmenu
		CreateMenu "Commit Version",MENUCOMMIT,p.projmenu
		CreateMenu "",0,p.projmenu
		p.projmenuprops=CreateMenu("Properties",MENUPROPS,p.projmenu)
		host.projectreq.projects=p
		Return p
	End Function
End Type

Type TByteBuffer Extends TStream
	Field	bytes:Byte[]
	Field	readpointer

	Method Read( buf:Byte Ptr,count )
		If count>readpointer count=readpointer
		If count=0 Return
		MemCopy buf,bytes,count
		readpointer:-count
		If readpointer MemMove bytes,Varptr bytes[count],readpointer
		Return count 
	End Method

	Method Write( buf:Byte Ptr,count )
		Local	n,m
		n=readpointer+count
		If n>bytes.length
			m=Max(bytes.length*1.5,n)
			bytes=bytes[..m]
		EndIf
		MemCopy Varptr bytes[readpointer],buf,count
		readpointer=n
		Return count
	End Method	
	
	Method LineAvail()
		Local	i
		For i=0 Until readpointer
			If bytes[i]=10 Return True
		Next
	End Method

	Method FlushBytes:Byte[]()
		Local res:Byte[]=bytes[..readpointer]
		readpointer=0
		Return res
	End Method
End Type

Type TObj
	Field	addr$,sync,refs,syncnext
	Method ShouldSync( pDebugTree:TDebugTree )
		If sync < pDebugTree.sync Then pDebugTree.QueueSync( Self )
	EndMethod
	Method HasSynced( pSync% )
		sync = pSync;syncnext = False
	EndMethod
End Type

Type TVar Extends TNode

	Field	owner:TDebugTree
	Field	obj:Object

	Method Free()
		If obj owner.RemoveObj obj
		obj=Null
		Super.Free()
	End Method

	Method SetVarName(n$)
		Local	p
		name=n
' if object ref set addr$ field	
		If name.find("$=")=-1 And name.find( ":String=" )=-1 And name.find(")=$")=-1
			p=name.find("=$")
			If p<>-1
				If TObj(obj) Then
					If TObj(obj).addr <> name[p+2..] Then 
						TDebugTree.RemoveObj obj
					Else
						TObj(obj).refs:-1
					EndIf	
				EndIf				
				obj=TDebugTree.AddObj(name[p+2..])
				'Request object dump if we are visible now that
				'we have updated our own object pointer.
				If Not IsHidden() Then Request()
				Return
			EndIf
			p=name.find("=Null")
			If p<>-1
				FreeKids
				TDebugTree.RemoveObj obj
				obj=Null
			EndIf
		EndIf
	End Method
	
	Method AddVar(name$)
		Local	v:TVar
		v=New TVar
		v.owner=owner
		Append v
		v.setvarname name
	End Method
	
	Method SetValue(val:TVar)
		Local	v:TVar,w:TVar,i
' if this is a reference to same object refresh values
		If obj And obj=val.obj
			If kids.IsEmpty()
				For v=EachIn val.kids
					AddVar v.name
				Next
			Else
				For v=EachIn val.kids
					If i<kids.count()
						w=TVar(kids.ValueAtIndex(i))
						If w w.SetVarName v.name
					Else
						AddVar v.name
					EndIf
					i:+1
				Next			
			EndIf
			Refresh
		EndIf	
' recurse so all references are updated
		If IsHidden() Then Return				'parent And parent.state=CLOSEDSTATE Return
		For v=EachIn kids
			v.SetValue val
		Next
	End Method
	
	Method Open(open=-1)
		For Local kid:TVar = EachIn kids
			kid.Request()
		Next
		Super.Open(open)
	EndMethod
	
	Method Request()
		If TObj(obj) Then TObj(obj).ShouldSync(owner)
	EndMethod
	
End Type

Type TScope Extends TVar
	Field	tree:TDebugTree
	Field	file$,line,column

	Method Invoke(command,argument:Object=Null)
		Select command
			Case TOOLACTIVATE
				tree.SelectScope Self,True
		End Select
	End Method
	
	Method SetScope(s:TScope)
		Local	v:TVar
		file=s.file
		line=s.line
		column=s.column
		s.obj=Self
		SetValue s
	End Method
	
	Method SetFile(debugtree:TDebugTree,f$)
		Local	p,q,r
		tree=debugtree
		p=Instr(f,"<")
		q=Instr(f,">")
		r=Instr(f,",")
		If p And q And r
			file=f[..p-1]
			line=Int(f[p..r-1])
			column=Int(f[r..q-1])
		EndIf
		obj=Self
	End Method
	
	Method Request()
		For Local kid:TVar = EachIn kids
			kid.Request()
		Next
	EndMethod
	
End Type

Type TDebugTree Extends TVar
	Global	sync
	Global	objlist:TList
	Field	host:TCodePlay
	Field	instack:TList
	Field	inscope:TScope
	Field	invar:TVar
	Field	infile$
	Field	inexception$
	Field	firststop
	Field	cancontinue
	
	Method Reset()
'		host.SetMode host.DEBUGMODE
		SetStack New TList
		objlist=New TList	
		instack=Null
		inscope=Null
		invar=Null
		infile=""
		inexception=""
		sync=0
		firststop=True
		cancontinue=False
	End Method

	Function AddObj:TObj(addr$)
		Local	o:TObj
		For o=EachIn objlist
			If o.addr=addr 
				o.refs:+1
				Return o
			EndIf
		Next
		o=New TObj
		o.addr=addr
		o.refs=1
		objlist.addlast o
		Return o
	End Function

	Function FindObj:TObj(addr$)
		Local	o:TObj
		For o=EachIn objlist
			If o.addr=addr Return o
		Next
	End Function
	
	Function RemoveObj(obj:Object)		':TObj
		Local	o:TObj
		o=TObj(obj)
		If Not o Return
		o.refs:-1
		If o.refs=0 
			objlist.Remove o
		EndIf
	End Function

	Method SyncVars()
		sync:+1
		For Local tmpVar:TVar = EachIn kids
			tmpVar.Request()
		Next
	End Method
	
	Method QueueSync( pObj:TObj )
		If Not pObj Then Return
		'Sync as soon as the debug pipe is clear
		'(see TOuputPanel.SendDumpRequests()).
		pObj.syncnext = True
	EndMethod
			
	Method SetStack(list:TList)
		Local	scope:TScope
		Local	openscope:TScope
		Local	s:TScope
		Local	count,i

		count=kids.count()			'root.varlist.count()
		For scope=EachIn list
			If i>=count
				Append scope		'root.Append scope
				s=scope
			Else
				s=TScope(kids.ValueAtIndex(i))
' simon was here				
				If s.name=scope.name
					s.SetScope scope
					scope.Free
				Else
					While kids.count()>i
						s=TScope(kids.ValueAtIndex(i))
						s.free
					Wend
					Append scope
					s=scope
					count=i+1
				EndIf
				
			EndIf
			If firststop
				If host.IsSourceOpen(s.file) openscope=s
			Else
				openscope=s
			EndIf
			i:+1
		Next
		While kids.count()>i
			scope=TScope(kids.ValueAtIndex(i))
			scope.free
		Wend 
		If list.isempty() Return
		If Not openscope openscope=TScope(list.First())
		If openscope SelectScope openscope,True
		Refresh
		firststop=False
	End Method

	Method SelectScope(scope:TScope,open)
		If Not scope Return		
		host.SetMode host.DEBUGMODE	' simon was here, smoved from reset
		If scope.file host.DebugSource scope.file,scope.line,scope.column
		scope.Open
'		If open
'			SelectTreeViewNode scope.node
'			scope.open
'		EndIf
	End Method

	Method ProcessError$(line$)
		Local	p
				
		While line[..1]=">" 
			line=line[1..]
		Wend
		If Not line Return

		If line[..2]<>"~~>" Return line
		
		line=line[2..]

		If invar
			If line="}"
				SetValue invar		'root
				invar.Free
				invar=Null
			Else
'				If Not invar.name
'					invar.name=line
'				Else
					invar.AddVar line
'				EndIf
			EndIf
			Return
		EndIf
		
		If instack 			
			If line="}" 
				
				SetStack instack
				instack=Null
				inscope=Null
				'Request first object dumps, and bump sync count
				SyncVars
				If inexception
					Notify inexception
					inexception=""
				EndIf
				Return
			EndIf
			
			If infile
				If line="Local <local>"
				Else
					inscope=New TScope
'					Print "inscope.line="+line
					inscope.name=line
					inscope.owner=Self
					instack.AddLast inscope
				EndIf
				If inscope inscope.setfile Self,infile
				infile=""
				Return
			EndIf

			If Instr(line,"@")=1 And Instr(line,"<")
				infile=line[1..]
			Else
				If inscope inscope.AddVar line
			EndIf

			Return
		EndIf

		If line[..20]="Unhandled Exception:"
			inexception=line
			host.output.WritePipe "t"
			cancontinue=False
			Return
		EndIf

		If line="StackTrace{" 
			instack=New TList
			Return
		EndIf

		If line="Debug:" Or line="DebugStop:"
			host.output.WritePipe "t"
			If Not cancontinue Then
				cancontinue=True
				host.RefreshToolbar()
			EndIf
			Return
		EndIf					
		
		If line[..11]="ObjectDump@"
			p=line.find("{")
			If p=-1 Return line
			line=line[11..p]
			invar=New TVar
			invar.obj=FindObj(line)
			invar.owner=Self
			Return
		EndIf
		
	End Method

	Function CreateDebugTree:TDebugTree(host:TCodePlay)
		Local	d:TDebugTree
		objlist=New TList
		d=New TDebugTree
		d.owner=d
		d.SetName "Debug"
		d.host=host
		d.Open
		Return d		
	End Function
End Type

Type TNodeView
	Field	owner:TNavBar
	Field	root:TNode
	Field	treeview:TGadget
	Field	index
	
	Method NewView()
		Local	n:TNode,hnode:TGadget
		hnode=SelectedTreeViewNode(treeview)
		n=root.Find(hnode,index)
		If n And n.parent owner.AddView n
	End Method

	Method OnEvent()
		Local	n:TNode
		
		n=root.Find(TGadget(EventExtra()),index)
		If Not n Return	'probably an eventgadgetselect -1 Notify("could not find in root");Return

		Select EventID()
			Case EVENT_GADGETSELECT
				n.invoke(TOOLSELECT)				
			Case EVENT_GADGETACTION
				n.invoke(TOOLACTIVATE)				
			Case EVENT_GADGETMENU
				n.invoke(TOOLMENU,Self)
			Case EVENT_GADGETOPEN
				n.open index
			Case EVENT_GADGETCLOSE
				n.close index
		End Select
	End Method
End Type

Type TNavBar Extends TEventHandler
	Field	host:TCodePlay
	Field	tabber:TGadget
	Field	viewlist:TList=New TList
	Field	selected:TNodeView
	Field	navmenu:TGadget
	
	Method SelectedView()
		If selected Return selected.index
	End Method
		
	Method SelectView(index)
		Local	n:TNodeView
		If index>=viewlist.count() Return
		n=TNodeView(viewlist.ValueAtIndex(index))
		If Not n Print "selectview failed";Return
		If n<>selected
			If selected HideGadget selected.treeview
			selected=n
		EndIf
		ShowGadget n.treeview
		SelectGadgetItem tabber,index
	End Method
	
	Method AddView(node:TNode)
		Local	n:TNodeView
		Local	index,root:TGadget
		For n=EachIn viewlist
			If n.root=node SelectView n.index;Return
		Next
		n=New TNodeView
		n.owner=Self
		n.root=node
		n.treeview=CreateTreeView(0,0,ClientWidth(tabber),ClientHeight(tabber),tabber)
		host.options.navstyle.Apply n.treeview
		SetGadgetLayout n.treeview,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED
		HideGadget n.treeview

		n.index=viewlist.Count()
		viewlist.AddLast n		
		
		AddGadgetItem tabber,node.name
		root=TreeViewRoot(n.treeview)
		node.setnode root,n.index
		SelectView n.index
		Return n.index
	End Method

	Method OnEvent()
		If EventSource()=tabber
			SelectView SelectedGadgetItem(tabber)				
		End If
		If selected And EventSource()=selected.treeview
			selected.OnEvent
		EndIf
	End Method

	Method Refresh()
		Local	view:TNodeView
		For view=EachIn viewlist
			host.options.navstyle.Apply view.treeview
		Next
	End Method

	Method Invoke(command,argument:Object=Null)
		If command=TOOLREFRESH Refresh()		
		If command=TOOLNEWVIEW And selected selected.NewView
	End Method

	Function CreateNavMenu:TGadget()
		Local	edit:TGadget
		edit=CreateMenu("&Nav",0,Null)
		CreateMenu "&New View",MENUNEWVIEW,edit
		Return edit
	End Function

	Function Create:TNavBar(host:TCodePlay, parent:TGadget)	',root:TNode)
		Local	n:TNavBar
		n=New TNavBar
		n.host=host	
		n.tabber=CreateTabber(0,0,ClientWidth(parent),ClientHeight(parent),parent)
		SetGadgetLayout(n.tabber,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED)
'		n.AddView root
		n.navmenu=CreateNavMenu()
		Return n		
	End Function

End Type

Type TOutputPanel Extends TToolPanel	'used build and run

	Field	host:TCodePlay
	Field	output:TGadget
	
	Field	process:TProcess
	Field	pipe:TStream

	Field	wpipe:TTextStream

	Field	user$,cmdline$,err$,post$
	Field	errbuffer:TByteBuffer
	Field	outputmenu:TGadget
	Field	posttool:TTool
	
	Method ClearDumpRequests()
		For Local o:TObj = EachIn host.debugtree.objlist
			o.HasSynced(o.sync)
		Next
	EndMethod
	
	Method SendDumpRequests()
		For Local o:TObj = EachIn host.debugtree.objlist
			If o.syncnext Then
				If o.addr <> "00000000" Then WritePipe "d"+o.addr
				o.HasSynced( host.debugtree.sync )
				'PollSystem()	'ReadPipes() on timertick, and checks for Stepping
			EndIf
		Next
	EndMethod
	
	Method Clear()
		If Not output Open()
		SetGadgetText output,""
	End Method
	
	Method WriteAscii(mess$)
		If Not output Open()
		mess=mess.Replace$(Chr(0),"")
		AddTextAreaText output,mess
	End Method

	Method Write(utf8$)
		Local mess$,i,c,d		
		If Not output Open()
		For i=0 Until utf8.Length		
			c=utf8[i]
			If c<128 
				mess:+Chr(c)
				d=0
				Continue
			EndIf
			If d
				mess:+Chr((d-192)*64+(c-128))				
				d=0
				Continue
			EndIf
			d=c
		Next
		mess=mess.Replace$(Chr(0),"")
		AddTextAreaText output,mess
	End Method

	Method Execute(cmd$,mess$="",exe$="",home=True,owner:TTool=Null)
		If Not output Open()
		If Not mess$ mess$=cmd$
		err$=""
		post$=exe
		posttool=owner
		host.SelectPanel Self
		host.debugtree.Reset
		
		If process And ProcessStatus(process)
			Delay 500
			If ProcessStatus(process)
				Notify "Current process still busy "+cmdline 
				Return
			EndIf
		EndIf
		cmd=cmd.Trim()
		process=CreateProcess(cmd$,HIDECONSOLE)
		If Not process Notify "Process Failure with "+cmd;Return
		If Not process.status() Notify "Process Failed to start "+cmd;process=Null;Return		
		pipe=Process.pipe
		wpipe=TTextStream.Create(pipe,TTextStream.UTF8)

		cmdline=cmd
		If home Clear
		Write mess$+"~n"
		errbuffer=New TByteBuffer
		host.RefreshToolbar	

	End Method

	Method WritePipe(l$)	
		Try
			If pipe pipe.WriteLine(l$)
		Catch ex:TStreamWriteException
			Write "~nProcess debug failure. Cannot write:~n"+l+"~n"
			Stop
		EndTry	
	End Method

	Method Go()
		WritePipe "r"
		host.debugtree.cancontinue = False
		host.RefreshToolbar()
	End Method
	
	Method StepOver()
		ClearDumpRequests()
		WritePipe "s"
	End Method
	
	Method StepIn()
		ClearDumpRequests()
		WritePipe "e"
	End Method

	Method StepOut()
		ClearDumpRequests()
		WritePipe "l"
	End Method
	
	Method Stop()
		If Not process Return		
		process.Terminate
		FlushPipes process.pipe,process.err		
		process.Close
		process=Null
		Write "~nProcess terminated~n"
		host.DebugExit
		Close
	End Method
	
	Method Wait()
		While process And process.status()
			PollSystem
		Wend
	End Method
	
	Method Invoke(command,argument:Object=Null)
		Select command
			Case TOOLSHOW 
				host.SetTitle
				If output ActivateGadget output	
			Case TOOLCLOSE
				host.RemovePanel Self
				output=Null
			Case TOOLCUT
				GadgetCut output
			Case TOOLCOPY
				GadgetCopy output
			Case TOOLPASTE
				GadgetPaste output
			Case TOOLSELECTALL 
				If output SelectTextAreaText output
			Case TOOLREFRESH
				host.options.outputstyle.apply output
		End Select
	End Method
	
	Method Close()
		host.SelectPanel host.activepanel
	End Method
	
	Method Escape()
		Stop
		Close
	End Method
	
	Function outputfilter(event:TEvent,context:Object)
		Local out:TOutputPanel=TOutputPanel(context)
		If Not out Return
		Select event.id
			Case EVENT_KEYDOWN
				If event.data=27
					out.Escape()
					Return 0
				EndIf
			Case EVENT_KEYCHAR
'				Print "output_keychar "+event.data
				out.writechar(event.data)
		End Select
		Return 1
	End Function
	
	Method OnEvent()
		If EventSource()=output
			If EventID()=EVENT_GADGETMENU
				PopupWindowMenu host.window,outputmenu
			EndIf
		EndIf
' Case EVENT_TIMERTICK
		If Not process Return		
		
		ReadPipes process.pipe,process.err

		Local status=process.status()
		If status=0
			process.terminate
			FlushPipes process.pipe,process.err
			process.close
			process=Null
			Write "~nProcess complete~n"
			host.DebugExit
			host.SelectPanel Self

			If err 
				host.ParseError err
			Else
				If post$
					Local menuaction=Int(post)
					If menuaction
						host.OnMenu menuaction,posttool
					Else				
'						Execute post$,"","",False,0
					EndIf
				Else
					If host.options.hideoutput Close
				EndIf
			EndIf
		EndIf	
		
	End Method
		
	Method FlushPipes(pipe:TPipeStream,errpipe:TPipeStream)
		ReadPipes(pipe,errpipe)
		Local bytes:Byte[]=errbuffer.flushbytes()
		If bytes
			Local line$=String.FromBytes(bytes,Len bytes)
			line=line.Replace$(Chr(13),"")
			If line<>">" Write line
		EndIf
	End Method
		
	Method ReadPipes(pipe:TPipeStream,errpipe:TPipeStream)
		Local	status
		Local	bytes:Byte[],line$

		bytes=pipe.ReadPipe()
		If bytes
			line$=String.FromBytes(bytes,Len bytes)
			line=line.Replace$(Chr(13),"")
			Write line
		EndIf

		bytes=errpipe.ReadPipe()
		If bytes 
			errbuffer.WriteBytes bytes,Len bytes 
		Else 
			SendDumpRequests()
		EndIf
		
'		If bytes Write String.FromBytes(bytes,bytes.length)
		While errbuffer.LineAvail()
			line$=errbuffer.ReadLine()
			line=host.debugtree.ProcessError(line)
			If line 
				Write line+"~n"
				err:+line+"~n"
			EndIf
		Wend
	End Method
	
	Method WriteChar(char)
		Local	pipe:TPipeStream
				
		If Not process Return		
		pipe=process.pipe
		If char=3			'CTRL-C
			Stop()
		EndIf
		If char=13			'ENTER
'			Write Chr(10)
			pipe.WriteLine user$
			user$=""
		EndIf
		If char=8			'DELETE
			If Len user
'				Local pos=TextAreaLen(output)
'				If pos SetTextAreaText output,"",pos-1,1,TEXTAREA_CHARS
				user=user[..Len user-1]
			EndIf
		EndIf
		If char>31
'			Write Chr(char)
			user:+Chr(char)
		EndIf
	End Method
		
	Method Open()
		If output codeplay.SelectPanel Self;Return
		codeplay.addpanel(Self)		
		output=CreateTextArea(0,0,ClientWidth(panel),ClientHeight(panel),panel,TEXTAREA_WORDWRAP)
		SetGadgetLayout output,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED
		SetGadgetFilter output,outputfilter,Self
		SetGadgetText output," "	'simon was here		
		host.options.outputstyle.apply output
	End Method

	Function CreateOutputMenu:TGadget()
		Local	edit:TGadget
		edit=CreateMenu("Edit",0,Null)
		CreateMenu "Cut",MENUCUT,edit
		CreateMenu "Copy",MENUCOPY,edit
		CreateMenu "Paste",MENUPASTE,edit
		CreateMenu "",0,edit
		CreateMenu "Stop",MENUSTOP,edit
		Return edit
	End Function

	Function Create:TOutputPanel(host:TCodePlay)
		Local	o:TOutputPanel
		o=New TOutputPanel
		o.host=host		
		o.name="Output"
		o.outputmenu=CreateOutputMenu()
'		o.Open
		Return o
	End Function

End Type

Type TCodeNode Extends TNode
	Field	owner:TOpenCode
	Field	pos,count
	'Field	groups:TMap=New TMap

	Method Invoke(command,argument:Object=Null)
		Select command
			Case TOOLACTIVATE
				owner.ShowPos(pos)
		End Select
	End Method

	Method Sync(snap:TNode)
		Local	n:TCodeNode		
		If snap.name<>name SetName(snap.name)
		n=TCodeNode(snap)
		If n pos=n.pos;count=n.count
		Super.Sync(snap)
	End Method
	
	Method SetName(n$)
		Local	p
		p=n.find("'")
		If p<>-1 n=n[..p]
		name=n.Trim()
'		If owner.host.options.sortcode 
		sortname=n
	End Method
	
	Method Free()
		owner = Null
		Super.Free()
	End Method
	
	Method AddCodeNode:TCodeNode(n$,p0,p1)
		Local c:TCodeNode
		Local p:TNode
		Local g:TGadget
		Local i,t$
		p=Self	
		i=n.find(" ")	'if space then group
		If i>0
			t=n[..i]
			n=n[i+1..]
Rem
			p=TNode(groups.ValueForKey(t))
			If Not p
				p=AddNode(t+"s")
				p.Open
				groups.insert t,p
			EndIf
EndRem
		EndIf
		c=New TCodeNode
		c.owner=owner
		c.setname n$
		c.pos=p0
		c.count=p1-p0
		p.Append c
		Return c
	End Method
End Type

Type TDiff
	Field	pos,count,del$,add$,pos0,count0,pos1
End Type

Type TOpenCode Extends TToolPanel

	Field	host:TCodePlay
	Field	textarea:TGadget
	Field	dirty=True
	Field	filesrc$,cleansrc$,cleansrcl$
	Field	Current:TDiff
	Field	undolist:TList=New TList
	Field	redolist:TList=New TList
	Field	helpcmd$,helpstring$
	Field	seek$
	Field	cursorpos,cursorlen,cursorline
	Field	oldpos,oldlen
	Field	isbmx,isc,iscpp,ishtml
	Field	deferpos
	Field	editmenu:TGadget
	Field	codenode:TCodeNode
	Field	dirtynode,uc

	Function IsNotAlpha(c)
		If c<48 Return True
		If c>=58 And c<65 Return True
		If c>=91 And c<95 Return True
		If c>=96 And c<97 Return True
		If c>=123 Return True
	End Function
	
	Function WordAtPos$(a$,p)
		Local	c,q,r,n
	' string literal
		q=a.findlast(EOL$,a.length-p)
		If q=-1 q=0
		For q=q To p-1
			If a$[q]=34 n=Not n;r=q
		Next
		If n	
			q=a.Find(Chr(34),r+1)+1
			If q=0 q=a.length
			Return a[r..q]
		EndIf
	' alphanumeric
		p=Min(p,a.length-1)	'simon was here - crash when checking at last char
		For p=p Until 0 Step -1	'simon was here unto->to
			If IsNotAlpha(a$[p]) Continue
			Exit
		Next
		For q=p-1 To 0 Step -1
			If IsNotAlpha(a$[q]) Exit
		Next
		For r=p To a.length-1
			If IsNotAlpha(a$[r]) Exit
		Next
		Return a$[q+1..r]
	End Function
	
	Function FirstDiff(s0$,s1$)
		Local	n,i
		n=Min(s0.length,s1.length)
		For i=0 Until n
			If s0[i]<>s1[i] Return i
		Next
		Return n		
	End Function
	
	Function LastDiff(s0$,s1$)
		Local	n,i,j
		n=Min(s0.length,s1.length)
		i=s0.length-1
		j=s1.length-1
		While n>0
			If s0[i]<>s1[j] Exit
			i:-1;j:-1;n:-1
		Wend
		Return i+1
	End Function
	
	Method parsebmx(n:TCodeNode)
		Local	src$,line,col
		Local	p,p1,r,t,m,f,l,e

		src=cleansrcl
		p1=src.length
		p=-1;r=-1;t=-1;m=-1;f=-1;l=-1
		While p<p1			'update rem,type,method,function,label pointers
			While r<=p
				r=FindToken("rem",src,r+1)
			Wend
			While t<=p
				t=FindToken("type",src,t+1)
			Wend
			While m<=p
				m=FindToken("method",src,m+1)
			Wend
			While f<=p
				f=FindToken("function",src,f+1)
			Wend
			While l<=p
				l=FindLabel(src,l+1)
			Wend
			If r<t And r<m And r<f And r<l
				p=FindEndToken("rem",src,r+1,True)
				Continue
			EndIf
			p=Min(t,Min(m,Min(f,l)))
			If p=src.length Exit		
			While (n And n.parent And p>n.pos+n.count) 
				If Not TCodeNode(n.parent)
					If n.parent.parent 
						n=TCodeNode(n.parent.parent)
					Else
						n=Null
					EndIf
				Else
					n=TCodeNode(n.parent)
				EndIf
			Wend
			If t<m And t<f And t<l
				e=src.find(EOL,t)
				n=n.AddCodeNode(cleansrc[t..e],t,FindEndToken("type",src,t,True))
				p=t+1
				Continue
			EndIf
			If m<f And m<l
				e=src.find(EOL,m)
				n.AddCodeNode(cleansrc[m..e],m,e)
				p=m+1
				Continue
			EndIf
			If f<l
				e=src.find(EOL,f)
				n.AddCodeNode(cleansrc[f..e],f,e)
				p=f+1
				Continue		
			Else
				e=src.find(EOL,l)
				n.AddCodeNode(cleansrc[l..e],l,e)
				p=l+1
				Continue				
			EndIf
		Wend
	End Method
	
	Method GetNode:TNode()
		Local	root:TCodeNode
		root=New TCodeNode
		root.name=StripDir(path)
		root.owner=Self
		root.count=cleansrc.length
		If isbmx parsebmx(root) ' stopped code view parse on non bmx files
		If codenode
			If host.options.sortcode root.sortkids
			codenode.Sync(root)	
			root.Free
		Else
			codenode=root
		EndIf
		Return codenode
	End Method
	
	Method HighlightLine(line,column = 0)
		Local tmpCharLineStart% = TextAreaChar(textarea,line)
		Local tmpLine$ = TextAreaText( textarea, line, 1, TEXTAREA_LINES ).Replace("~r","").Replace("~n",""), i%
		For i = column Until tmpLine.length
			If IsNotAlpha(tmpLine[i]) Then tmpCharLineStart:+1 Else Exit
		Next
		SelectTextAreaText textarea,line-1,0,TEXTAREA_LINES
		SelectTextAreaText textarea,line+1,0,TEXTAREA_LINES
		If i = tmpLine.length Or ..
		( TextAreaCharX( textarea, tmpCharLineStart + tmpLine.length-i ) - TextAreaCharX( textarea, tmpCharLineStart ) >= ClientWidth(textarea) ) Then
			SelectTextAreaText textarea,line,1,TEXTAREA_LINES
		Else
			SelectTextAreaText textarea,tmpCharLineStart,tmpLine.length-i,TEXTAREA_CHARS
		EndIf
	EndMethod
	
	Method ShowPos(pos)
		host.SelectPanel Self
		HighlightLine TextAreaLine(textarea,pos)
		UpdateCursor
		ActivateGadget textarea
	End Method

	Method Debug(line,column)
		HighlightLine line-1
		UpdateCursor
	End Method

	Method Edit()
		SelectTextAreaText textarea,cursorpos,0,TEXTAREA_CHARS
		ActivateGadget textarea
		UpdateStatus
	End Method
	
	Method UpdateStatus()
		Local	c
		c=cursorpos+cursorlen
		If cursorline c=c-TextAreaChar(textarea,cursorline-1)
		host.SetStatus helpstring+"~t~t"+"Line: "+(cursorline)+" Char: "+(c+1)+"     "
	End Method
	
	Method UpdateCursor()
		Local	l	
		oldpos=cursorpos
		oldlen=cursorlen
		cursorpos=TextAreaCursor(textarea,TEXTAREA_CHARS)
		cursorlen=TextAreaSelLen(textarea,TEXTAREA_CHARS)
		If cursorpos<>oldpos Or cursorlen<>oldlen
			l=TextAreaLine(textarea,cursorpos)+1
			If l<>cursorline And dirtynode
				GetNode().Refresh
				dirtynode=False
				If deferpos UpdateCode	'SetCode cleansrc
			EndIf
			cursorline=l
			UpdateStatus()
			PollSystem
		EndIf
	End Method

' tdiff - pos del$ add$

	Method CalcDiff:TDiff(src$)
		Local	d:TDiff

		If src.length<>cleansrc.length
			d=New TDiff
			d.pos0=cursorpos
			d.count0=cursorlen
			d.pos=oldpos
			d.count=oldlen
			If cursorlen And oldlen							'block modified
				d.del=cleansrc[oldpos..oldpos+oldlen]
				d.add=src[oldpos..cursorpos+cursorlen]
				d.pos1=oldpos
			Else
				If cursorpos<=oldpos And cursorlen<=oldlen	'backspace
					d.del=cleansrc[cursorpos..cursorpos+cleansrc.length-src.length]
					d.pos1=cursorpos
				Else										'insert
					d.del=cleansrc[oldpos..oldpos+oldlen]
					d.add=src[oldpos..cursorpos+cursorlen]
					d.pos1=oldpos
				EndIf
			EndIf
			Return d		
		EndIf		
		If cursorpos>oldpos									'overwrite
			d=New TDiff
			d.pos0=cursorpos
			d.count0=cursorlen
			d.pos=oldpos
			d.count=oldlen
			d.del=cleansrc[oldpos..cursorpos]
			d.add=src[oldpos..cursorpos]
			d.pos1=oldpos
			Return d		
		EndIf		
	End Method

	Method UpdateCode(makeundo=True)
		Local	cpos,src$
		Local	d:TDiff

		src=TextAreaText(textarea)		
		d=CalcDiff(src)
		If d		
			If makeundo
				undolist.AddLast d
				redolist.Clear
			EndIf
			SetCode src,d
			dirtynode=True
		Else
			If deferpos SetCode src
		EndIf
	End Method
	
	Method Undo()
		Local	d:TDiff
		If undolist.isempty() Return
		d=TDiff(undolist.RemoveLast())
		redolist.AddLast d
		SetTextAreaText textarea,d.del,d.pos1,d.add.length
		SelectTextAreaText(textarea,d.pos,d.count)
		SetCode TextAreaText(textarea),d
		UpdateCursor
	End Method

	Method Redo()
		Local	d:TDiff
		If redolist.isempty() Return
		d=TDiff(redolist.RemoveLast())
		undolist.AddLast d
		SetTextAreaText textarea,d.add,d.pos,d.del.length
		SelectTextAreaText(textarea,d.pos0,d.count0)
		UpdateCursor
		SetCode TextAreaText(textarea),d
	End Method

	Method Refresh()
		Local	rgb:TColor
		Local	src$
		SetTextAreaTabs textarea,host.options.tabsize
		SetTextAreaFont textarea,host.options.editfont
		rgb=host.options.editcolor
		SetTextAreaColor textarea,rgb.red,rgb.green,rgb.blue,True
		rgb=host.options.styles[0].color
		SetTextAreaColor textarea,rgb.red,rgb.green,rgb.blue,False
		src=cleansrc
		cleansrc=""
		cleansrcl=""
		cursorpos=0
		SetCode(src)
	End Method

	Function IsntAlphaNumeric(c)		'lowercase test only
		If c<47 Return True
		If c>=58 And c<95 Return True
		If c=96 Return True
		If c>=123 Return True
	End Function
	
	Function IsntAlphaNumericOrQuote(c)		'lowercase test only
		If c=34 Return False
		If c<47 Return True
		If c>=58 And c<95 Return True
		If c=96 Return True
		If c>=123 Return True
	End Function

	Function IsCode(src$,p)
		Local	l,q,n
		l=src.FindLast(EOL$,src.length-p)
		If l=-1 l=0
		q=src.Find("'",l)
		If q<>-1 And q<p Return
		q=l
		While q<p
			q=src.Find(QUOTES$,q)+1
			If q=0 Exit
			If q<=p n:+1
		Wend
		If n&1 Return
		Return True		
	End Function

	Function FindLabel(src$,pos)
		Local	p,q,c
		While pos>=0
			p=src.Find("#",pos)
			If p=-1 Exit
			q=p
			While q>0
				q:-1
				c=src[q]
				If c=13 Return p
				If c=10 Return p
				If c=32 Or c=9 Continue
				Exit
			Wend
			If q=0 Return p
			pos=p+1
		Wend
		Return src.length	
	End Function
	
	Function FindToken(token$,src$,pos)	'lowercase src only!
		Local	p,c,n
		n=token.length
		While pos>=0
			p=src.Find(token,pos)
			If p=-1 Exit
			c=10 If p>0 c=src[p-1]
			If isntalphanumeric(c) 
				If p+n<src.length c=src[p+n]
				If isntalphanumeric(c) 
					If iscode(src,p)
						If p<4 Or src[p-4..p]<>"end " Return p
					EndIf
				EndIf
			EndIf
			pos=p+1
		Wend
		Return src.length
	End Function

	Function FindEndToken(token$,src$,pos,returnlast=False)	'if true returns first character after endtoken
		Local	p,q,e$,n
		
		p=pos
		e$="end"+token
		n=e.length
		While p<src.length
			p=src.Find(e$,p)
			If p=-1 Exit
			If p+n=src.length Or isntalphanumeric(src[p+n])
				If iscode(src,p)
					If p=0 Or isntalphanumeric(src[p-1]) Exit
				EndIf
			EndIf
			p=p+n
		Wend
		If p=-1 p=src.length Else If returnlast p:+n
		q=pos
		e$="end "+token
		n=e.length
		While q<src.length
			q=src.Find(e$,q)
			If q=-1 Exit
			If q+n=src.length Or isntalphanumeric(src[q+n])
				If iscode(src,q)
					If q=0 Or isntalphanumeric(src[q-1]) Exit
				EndIf
			EndIf
			q=q+n
		Wend
		If q=-1 q=src.length Else If returnlast q:+n
		Return Min(p,q)
	End Function

	Function IsFirstCharOnLine(src$,pos)
		Local	i,c
		For i=1 To pos
			c=src[pos-i]
			If c=10 Or c=13 Return True
			If c>32 Return False
		Next
		Return True
	End Function

' rem and endrem must be first nonwhitespace on line - following funcs are for lowercase src only

	Function FindRem(src$,pos)
		While pos<src.length
			pos=FindToken("rem",src,pos)
			If pos=src.length Exit
			If IsFirstCharOnLine(src,pos) Return pos
			pos:+1
		Wend
		Return pos
	End Function

	Function FindEndRem(src$,pos,returnlast=False)
		Local	i,c		
		While pos<src.length
			pos=FindEndToken("rem",src,pos)
			If pos=src.length Exit
			If IsFirstCharOnLine(src,pos)
				If returnlast 
					If src[pos+5]=Asc("e") Or src[pos+5]=Asc("E") pos:+1
					pos:+6
				EndIf
				Return pos
			EndIf
			pos:+1
		Wend
		Return src.length
	End Function

	Function FindPrevRem(src$,pos)	'lowercase src only!
		Local	p,c
		While pos>0
			If pos>=src.length Exit	'fixed endrem on lastline overrun
			p=src.FindLast("rem",src.length-pos)
			If p=-1 Exit						
			If isntalphanumeric(src[p+3]) And IsFirstCharOnLine(src,p) Return p			
			pos=p-1
		Wend
		Return -1
	End Function

	Method WasRemmed(pos,src$)
		Local	s$,p
		s$=cleansrcl
		p=src.length-s.length
		If p<0 pos:-p		
		p=FindPrevRem(s$,pos+3)
		If p=-1 Return
		p=FindEndRem(s$,p)
		If pos<p Return True
	End Method

	Method CheckDirty(src$)
		Local	bool
		bool=True
		If src=filesrc And undolist.isempty() bool=False
		SetDirty bool
	End Method

	Method SetCode(src$,diff:TDiff=Null)
		Local	i,p,p1,q,r,a,t$,h$,lsrc$,r0,r1,cpos,autocap
		Local	style:TTextStyle[4],s:TTextStyle

' update dirty flag	
		CheckDirty src
		If src=cleansrc And Not deferpos And Not diff Return	
		If Not isbmx Or Not host.quickhelp Or Not host.options.syntaxhighlight
			cleansrc=src
			cleansrcl=src.ToLower()
			Return
		EndIf
' doit
		autocap=host.options.autocapitalize
		lsrc=src.ToLower()

		cpos=TextAreaCursor(textarea,TEXTAREA_CHARS)
		LockTextArea textarea
		style=host.options.styles
' calculate highlight region
		If deferpos
			p=deferpos
			p1=p
			deferpos=0
		Else
			If diff
				p=diff.pos
				p1=p+diff.add.length
			Else
				p=firstdiff(src,cleansrc)
				p1=lastdiff(src,cleansrc)
			EndIf
			q=src.length-cleansrc.length
			If p1-p<q p1=p+q
			If p1<p p1=p
		EndIf
' round region to line breaks
'		Print "p="+p+" p1="+p1
		If p>0 p:-1
		If p>src.length p=src.length
		p=src.findlast(EOL,src.length-p)+1
		p1=src.find(EOL,p1)+1
		If p1=0 p1=Len src
' if endrem between p0,p1 and next rem after p1 move p1 forwards
		r1=FindEndRem(lsrc,p)
		If r1<p1 And wasremmed(r1+6,lsrc)
			r0=FindRem(lsrc,r1+6)
			If r0>p1 p1=r0
		EndIf
' if rem between p0,p1 and matching endrem after p1 move p1 forewards 
		r0=FindPrevRem(lsrc,p1)
		If r0>=p And r0+3<>cpos	'defer fix
			r1=FindEndRem(lsrc,r0,True)
			If r1>p1 p1=r1
		EndIf
' if rem before p0 and matching endrem after p0 highlight to endrem and move p0 forwards
		r0=FindPrevRem(lsrc,p)
		If r0<>-1 And r0<p
			r1=FindEndRem(lsrc,r0,True)
			If r1>p
				s=style[COMMENT]
				If r1>p s.Format(textarea,p,r1-p)
				If autocap And r1<src.length
					If lsrc[r1-6..r1]="endrem" And src[r1-6..r1]<>"EndRem" SetTextAreaText textarea,"EndRem",r1-6,6
					If lsrc[r1-7..r1]="end rem" And src[r1-7..r1]<>"End Rem" SetTextAreaText textarea,"End Rem",r1-7,7
				EndIf
				p=r1
			EndIf
		EndIf	
' if was remmed and now isn't move p1 down to nearest rem or endrem
		If WasRemmed(p,lsrc)
			r0=FindRem(lsrc,p)
			r1=FindEndRem(lsrc,r0,True)
			p1=Max(p1,Min(r0,r1))	
		EndIf
' highlight code
		s=style[NORMAL]
		If p1>p s.format(textarea,p,p1-p)
		While p<p1
			host.UpdateProgress("Highlighting Code",(p*100)/p1)
			a=src[p]
' quoted strings
			If a=34
				q=p1
				r=src.find(Chr(34),p+1)
				If r>-1 And r<q q=r+1
				r=src.find(EOL,p+1)
				If r>-1 And r<q q=r
				s=style[QUOTED]
				s.format(textarea,p,q-p)
				p=q
				Continue
			EndIf
' single line comments
			If a=39
				q=p1
				r=src.find(EOL,p+1)
				If r>-1 And r<q q=r
				s=style[COMMENT]
				s.format(textarea,p,q-p)
				p=q
				Continue				
			EndIf
' tokens
			If (a>=65 And a<91) Or (a>=97 And a<123) Or (a=95)
				q=p+1
				While q<p1
					a=src[q]
					If a<48 Exit	'changed to include dot (chr 47)
					If a>=58 And a<65 Exit
					If a>=91 And a<95 Exit
					If a=96 Exit
					If a>122 Exit
					q:+1
				Wend
				t$=src[p..q]
				h$=host.quickhelp.token(t$)
				If h$
					If h$<>t$ And autocap
						If q<>cpos
							SetTextAreaText textarea,h$,p,Len h
						Else
							deferpos=q
						EndIf
					EndIf
					s=style[KEYWORD]
					If h$="Rem" And IsFirstCharOnLine(lsrc,p)	' Not (p>4 And lsrc[p-4..p]="end ")
						If q<>cpos
							q=FindEndRem(lsrc,p,True)
							s=style[COMMENT]
						Else
							deferpos=q
						EndIf						
					EndIf
					s.format(textarea,p,q-p)
				EndIf
				p=q
				Continue
			EndIf
			p:+1
		Wend
		UnlockTextArea textarea
		cleansrc=src
		cleansrcl=lsrc
'		CheckDirty src	simon was here
	End Method

	Method AutoIndent()
		Local	t$,p,q,c,n
		c=TextAreaCursor(textarea,TEXTAREA_CHARS)
		n=TextAreaSelLen(textarea,TEXTAREA_CHARS)
		If c<cleansrc.length 
			p=cleansrc.FindLast(EOL$,cleansrc.length-(c-1))+1
			q=p
			While cleansrc[q]=9 And q<c
				q:+1
			Wend
			If q>c q=c
		EndIf
		SetTextAreaText textarea,EOL$+cleansrc[p..q],c,n
		SelectTextAreaText textarea,c+1+q-p,0			
		UpdateCursor
		UpdateCode
	End Method
	
	Method IndentCode()
		Local	cpos,p0,p1,i,a$
' blockindent
		p0=TextAreaCursor(textarea,TEXTAREA_LINES)
		p1=TextAreaSelLen(textarea,TEXTAREA_LINES)
' v122: make sure the entire block is selected (start cursor pos may in the middle of the line)
		SelectTextAreaText textarea , p0 , p1 , TEXTAREA_LINES
		UpdateCursor
		For i=0 Until p1
			a$="~t"+TextAreaText(textarea,p0+i,1,TEXTAREA_LINES)
			SetTextAreaText textarea,a$,p0+i,1,TEXTAREA_LINES
		Next
		SelectTextAreaText textarea,p0,p1,TEXTAREA_LINES
		UpdateCursor
		UpdateCode
	End Method

	Method OutdentCode()
		Local	cpos,p0,p1,i,a$,modified
' blockoutdent
		p0=TextAreaCursor(textarea,TEXTAREA_LINES)
		p1=TextAreaSelLen(textarea,TEXTAREA_LINES)
' v122: make sure the entire block is selected (start cursor pos may in the middle of the line)
		SelectTextAreaText textarea , p0 , p1 , TEXTAREA_LINES
		UpdateCursor
		For i=0 Until p1
			a$=TextAreaText(textarea,p0+i,1,TEXTAREA_LINES)
			If a[0]=9 a$=a$[1..];modified=True
			SetTextAreaText textarea,a$,p0+i,1,TEXTAREA_LINES
		Next
		If Not modified
			For i=0 Until p1
				a$=TextAreaText(textarea,p0+i,1,TEXTAREA_LINES)
				If a[0]=32 a$=a$[1..]
				SetTextAreaText textarea,a$,p0+i,1,TEXTAREA_LINES
			Next	
		EndIf
		SelectTextAreaText textarea,p0,p1,TEXTAREA_LINES
		UpdateCursor
		UpdateCode
	End Method

	Function FilterKey(event:TEvent,context:Object)
		Local	this:TOpenCode
		Local	id,key,mods
'		If event.id<>EVENT_KEYCHAR Return 1
		id=event.id
		key=event.data
		mods=event.mods
		this=TOpenCode(context)
?MacOS
		If key=25 And mods=1 key=9
?
		If id=EVENT_KEYCHAR And this And key=9 And TextAreaSelLen( this.textarea,TEXTAREA_CHARS )
			Select mods
				Case 0
					this.IndentCode
				Case 1
					this.OutdentCode
			End Select
			Return 0
		EndIf

		If id=EVENT_KEYDOWN And this And key=13 And this.host.options.autoindent 
			this.AutoIndent 
			Return 0
		EndIf
		
		Return 1
	End Function

	Method OnEvent()
 		Select EventSource()
			Case textarea 
				Select EventID() 
					Case EVENT_GADGETMENU
						PopupWindowMenu host.window,editmenu
					Case EVENT_GADGETACTION
						UpdateCode
					Case EVENT_GADGETSELECT
						UpdateCursor
				End Select
		End Select
	End Method
			
	Method SetDirty( bool )
		If dirty=bool Return
		dirty=bool
		name=StripDir(path)
		If (dirty) name:+"*"
		If (host.lockedpanel=Self) name="build:"+name
		host.RefreshPanel Self
		PollSystem
	End Method
	
	Method SetLocked( bool )
		Local locked:TOpenCode
		locked=TOpenCode(host.lockedpanel)
		If locked And locked<>Self locked.SetLocked False
		name=StripDir(path)
		If (dirty) name:+"*"
		If (bool) 
			name="build:"+name
			host.lockedpanel=Self
		Else
			host.lockedpanel=Null			
		EndIf
		host.RefreshPanel Self
	End Method
	
	Method Help()
		Local	p,l$,a$
		If Not host.quickhelp Return
		p=TextAreaCursor(textarea,TEXTAREA_CHARS)
		a$=WordAtPos(cleansrc,p)
		If a$=helpcmd
			l$=host.quickhelp.link(a$)
			If l$ 
				host.helppanel.go host.bmxpath+l$
			EndIf
		Else
			helpcmd=a$
			helpstring$=host.quickhelp.help(a$)
			UpdateStatus	'host.setstatus helpstring$
		EndIf
	End Method

	Method Find()
		Local	p,l$,a$
		p=TextAreaCursor(textarea,TEXTAREA_CHARS)
		a$=WordAtPos(cleansrc,p)
		host.findreq.ShowFind a$
	End Method
		
	Method FindNext(s$)
		Local	p,l$
		If s seek=s Else s=seek
		p=TextAreaCursor(textarea,TEXTAREA_CHARS)
		p:+TextAreaSelLen(textarea,TEXTAREA_CHARS)
' case insensitive
		l$=s.toLower()
		p=cleansrcl.Find(l$,p)
		If p=-1 p=cleansrcl.Find(l$)
' case sensitive
'		p=cleansrc.Find(s$,p+1)
'		if p=-1 p=cleansrc.Find(s$)
		If p=-1
			Notify "Could not find '"+s$+"'."
			Return False
		Else
			SelectTextAreaText textarea,p,Len s,TEXTAREA_CHARS
			UpdateCursor
			Return True
		EndIf
	End Method

	Method ReplaceAll(s$,r$)
		s=s.ToLower()
		Local t$=TextAreaText( textarea ).ToLower()
		Local c=TextAreaCursor(textarea,TEXTAREA_CHARS),i,p
		Repeat
			Local i2=t.Find( s,i )
			If i2=-1 Exit
			p:+i2-i
			i=i2+s.length
			SelectTextAreaText textarea,p,s.length
			UpdateCursor
			UpdateCode		
			SetTextAreaText textarea,r,p,s.length
			If p<c c=c+r.length-s.length			
			p:+r.length
			SelectTextAreaText textarea,p,0
			UpdateCursor
			UpdateCode
		Forever
		SelectTextAreaText textarea,c,0
		UpdateCursor
	End Method
	
	Method FindReplace(r$)
		Local	p,n,f$,x$
		p=r.Find(Chr(0))
		If p>0
			f$=r[..p]
			r$=r[p+1..]
			ReplaceAll f$,r$
		Else
			p=TextAreaCursor(textarea,TEXTAREA_CHARS)
			n=TextAreaSelLen(textarea,TEXTAREA_CHARS)
			If n=0 Return
			SetTextAreaText textarea,r$,p,n
			SelectTextAreaText textarea,p+Len r,0
			UpdateCursor
			UpdateCode		
		EndIf
		Return True
	End Method
	
	Method ReadSource(path$)
		Local	src$		
		src=LoadText(path)
		src=src.Replace(Chr(13),"")
		src=src.Replace(Chr(11),"")
		LockTextArea textarea
		SetTextAreaText textarea,src
		UnlockTextArea textarea
		filesrc=TextAreaText(textarea)
		cleansrc=""
		cleansrcl=""
		ActivateGadget textarea		
	End Method
	
	Method SaveSource(file$)
		Local	src$		
		If host.options.autobackup
			DeleteFile file+".bak"
			RenameFile file,file+".bak"
		EndIf		
		src=TextAreaText(textarea)
		filesrc=src
		src=src.Replace$(Chr(13),Chr(10))
		src=src.Replace$(Chr(11),"")
		Local txt$=src.Replace$(Chr(10),Chr(13)+Chr(10))		
		SaveText txt,file		
		path=host.FullPath$(file)
		dirty=True
		SetDirty False
		host.AddRecent(path$)
		Return True
	End Method

	Method BuildSource(quick,debug,threaded,gui,run,univ,target,_b_wx_max:Int = False)
		Local cmd$,out$,arg$		
		If isbmx Or isc Or iscpp
			cmd$=quote(host.bmkpath)
			cmd$:+" makeapp"
			If run cmd$:+" -x"
			If debug cmd$:+" -d" Else cmd$:+" -r"	'-v
			If threaded cmd$:+" -h"
			' Allow bmk to choose the wxWidgets OSX appstub
			If (Not target Or (target & 1)) And _b_wx_max Then cmd$ :+ " -b bah.appstub"
			If gui cmd$:+" -t gui"
			If Not quick cmd$:+" -a"
			If (Not target Or (target & 1)) And univ cmd$:+ " -i" ' BaH
			If target & 2 cmd$:+ " -l win32" ' hardcoded for now. Win32 only
			If debug Or threaded
				out=StripExt(host.FullPath(path))
				If debug out:+".debug"
				If threaded out:+".mt"
				cmd:+" -o "+quote(out$)+" "
			EndIf		
			cmd$:+" "+quote(host.FullPath(path))
			If run
				arg$=host.GetCommandLine()
				If arg cmd$:+" "+arg
			EndIf
			host.execute cmd,"Building "+StripExt(StripDir(path))	',exe$
		Else
			If ishtml
				host.helppanel.Go "file://"+path 
			Else
'see what the system shell thinks of the file
				Local cd$=CurrentDir()
				ChangeDir ExtractDir(path)
				cmd=StripDir(path)
				host.execute cmd,"Building "+cmd
				ChangeDir cd
			EndIf			
		EndIf
'		print cmd
	End Method
	
	Method Save()
		Local	file$
		file=path
		If host.IsTempPath(path) 
			file=RequestFile("Save As",FileTypeFilters,True,"")
			If file="" Return False
			If ExtractExt(file)="" file=file+".bmx"
			dirty=True
		EndIf
		If dirty SaveSource(file)
		Return True
	End Method
' common command interface

	Method Invoke(command,argument:Object=Null)
		Local	file$,ex$
		Local	p,res
		Select command
			Case TOOLSHOW
				host.SetCodeNode GetNode()
				host.SetTitle path				
' simon was here				If textarea Edit
				If textarea ActivateGadget textarea

			Case TOOLCLOSE
				If dirty
					p=Proceed("Save changes to "+name+"?")	'the current file?
					If p=-1 Return True
					If p=1 
						If Not Save() Return True
					EndIf
				EndIf
				If codenode codenode.Free();codenode=Null
				'Added just in case MaxGUI driver doesn't handle properly.
				SetGadgetFilter textarea,Null,Null
				'Seb gone.
				host.RemovePanel Self
				FreeGadget(editmenu)
			Case TOOLSAVE 
				Save
			Case TOOLQUICKSAVE 
				file=path
				If dirty SaveSource(file)
			Case TOOLSAVEAS
				file=path
				If host.IsTempPath(path) file$=""
				file=RequestFile("Save As",FileTypeFilters,True,file)
				If file="" Return
				ex$=ExtractExt(file)
				If ex$="" 
					file=file+".bmx"
					isbmx=True
				Else
					isbmx=(ex.ToLower()="bmx")
					ishtml=(ex.ToLower()="html")
					isc=(ex.ToLower()="c")
					iscpp=(ex.ToLower()="cpp" Or ex.ToLower()="cxx")
				EndIf				
				SaveSource(file$)
				Refresh
				GetNode().Refresh
				setdirty False
				host.SetTitle path
			Case TOOLGOTO
				Local line=Int(String(argument))
				SelectTextAreaText textarea,line-1,0,TEXTAREA_LINES				
				UpdateCursor
				ActivateGadget textarea		
			Case TOOLFIND
				Find
			Case TOOLFINDNEXT
				res=FindNext(String(argument))
'				ActivateGadget textarea
				Return res		
			Case TOOLREPLACE
				Return FindReplace(String(argument))	
			Case TOOLBUILD
				BuildSource host.quickenabled,host.debugenabled,host.threadedenabled,host.guienabled,False,host.univenabled, ..
						host.targetmacenabled | host.targetwinenabled Shl 1| host.targetlinenabled Shl 2 
			Case TOOLRUN 
				BuildSource host.quickenabled,host.debugenabled,host.threadedenabled,host.guienabled,True,host.univenabled, ..
						host.targetmacenabled | host.targetwinenabled Shl 1| host.targetlinenabled Shl 2
			Case TOOLBUILD_WX
				BuildSource host.quickenabled,host.debugenabled,host.threadedenabled,host.guienabled,False,host.univenabled, ..
						host.targetmacenabled | host.targetwinenabled Shl 1| host.targetlinenabled Shl 2, host.wxBuildAvailable
			Case TOOLRUN_WX 
				BuildSource host.quickenabled,host.debugenabled,host.threadedenabled,host.guienabled,True,host.univenabled, ..
						host.targetmacenabled | host.targetwinenabled Shl 1| host.targetlinenabled Shl 2, host.wxBuildAvailable
			Case TOOLLOCK
				SetLocked True
			Case TOOLUNLOCK
				SetLocked False			
			Case TOOLHELP
				Help
			Case TOOLUNDO
				Undo
			Case TOOLREDO
				Redo
			Case TOOLREFRESH
				Refresh
			Case TOOLCUT
				GadgetCut textarea
			Case TOOLCOPY
				GadgetCopy textarea
			Case TOOLPASTE
				GadgetPaste textarea
			Case TOOLSELECTALL 
				SelectTextAreaText textarea
			Case TOOLINDENT
				IndentCode
			Case TOOLOUTDENT
				OutdentCode
			Case TOOLPRINT
				GadgetPrint textarea
		End Select
	End Method
		
	Function CreateEditMenu:TGadget()
		Local	edit:TGadget
		edit=CreateMenu("&Edit",0,Null)
		CreateMenu "Quick Help",MENUQUICKHELP,edit
		CreateMenu "",0,edit
		CreateMenu "Cut",MENUCUT,edit
		CreateMenu "Copy",MENUCOPY,edit
		CreateMenu "Paste",MENUPASTE,edit
		CreateMenu "",0,edit
		CreateMenu "Select All",MENUSELECTALL,edit
		CreateMenu "",0,edit
		CreateMenu "Block Indent",MENUINDENT,edit
		CreateMenu "Block Outdent",MENUOUTDENT,edit
		CreateMenu "",0,edit
		CreateMenu "Find",MENUFIND,edit
		CreateMenu "Find Next",MENUFINDNEXT,edit
		CreateMenu "Replace",MENUREPLACE,edit
		CreateMenu "Goto Line",MENUGOTO,edit
		Return edit
	End Function
	
	Method MakePathTemp()
' prepends "." to file name with code borrowed from SaveAs		
		Local file$=ExtractDir(path)+"/."+StripDir(path)
		SaveSource(file$)
'		Refresh
		GetNode().Refresh
'		setdirty False
		host.SetTitle path
	End Method
	
	Function Create:TOpenCode(path$,host:TCodePlay)
		Local	code:TOpenCode
		Local	stream:TStream
		Local	isnew
		If path
			If FileType(path)<>FILETYPE_FILE
				Return Null
			EndIf
			stream=ReadFile(path)
			If Not stream 
'				Notify "Open could not read from "+path		
				Return Null
			EndIf
			CloseFile stream
		Else
			TEMPCOUNT:+1
			path=host.bmxpath+"/tmp/untitled"+TEMPCOUNT+".bmx"
			isnew=True
		EndIf
		code=New TOpenCode
		code.host=host
		code.active=True
		code.path=host.FullPath(path)
		code.editmenu=CreateEditMenu()
		codeplay.addpanel(code)
		code.textarea=CreateTextArea(0,0,ClientWidth(code.panel),ClientHeight(code.panel),code.panel,0)
		SetGadgetFilter code.textarea,code.FilterKey,code
		SetTextAreaText code.textarea,"~n"
		SetGadgetLayout code.textarea,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED
		code.Refresh()
		
		If isnew 
			code.SaveSource path
			code.filesrc="~n"
			ActivateGadget code.textarea
		Else
			host.UpdateProgress "Reading Stream"
			code.ReadSource(path)
		EndIf
		
		If ExtractExt(path).toLower()="bmx" code.isbmx=True
		If ExtractExt(path).toLower()="c" code.isc=True
		If ExtractExt(path).toLower()="cpp" code.iscpp=True
		If ExtractExt(path).toLower()="cxx" code.iscpp=True
		If ExtractExt(path).toLower()="html" code.ishtml=True
		If ExtractExt(path).toLower()="htm" code.ishtml=True
		code.UpdateCode False
		code.filesrc=TextAreaText(code.textarea)
		Return code
	End Function

End Type

Type TRect
	Field		x,y,w,h

	Method Set(xpos,ypos,width,height)
		x=xpos;y=ypos;w=width;h=height
	End Method
	
	Method ToString$()
		Return ""+x+","+y+","+w+","+h
	End Method

	Method FromString(s$)
		Local	p,q,r
		p=s.Find(",")+1;If Not p Return
		q=s.Find(",",p)+1;If Not q Return
		r=s.Find(",",q)+1;If Not r Return
		x=Int(s[..p-1])
		y=Int(s[p..q-1])
		w=Int(s[q..r-1])
		h=Int(s[r..])
	End Method
	
	Method IsOutside(tx,ty,tw,th)
		If x+w<=tx Or y+h<=ty Return True
		If x>=tx+tw Or y>=ty+th Return True	
	End Method

End Type

Type TCodePlay

	Const EDITMODE=1
	Const DEBUGMODE=2
	
	Field bmxpath$,bmkpath$
	Field panels:TToolPanel[]
	Field helppanel:THelpPanel
	Field currentpanel:TToolPanel
	Field output:TOutputPanel
	Field lockedpanel:TToolPanel
	Field activepanel:TToolPanel
	
	Field cmdlinereq:TCmdLineRequester
	Field cmdline$
	Field syncmodsreq:TSyncModsRequester
	Field gotoreq:TGotoRequester
	Field findreq:TFindRequester
	Field replacereq:TReplaceRequester
	Field options:TOptionsRequester
'	Field progress:TProgressRequester
	Field activerequester:TRequester
	Field projectreq:TProjectRequester
	Field projectprops:TProjectProperties
	Field searchreq:TSearchRequester
	
	Field eventhandlers:TList=New TList
	Field window:TGadget,menubar:TGadget,toolbar:TGadget,client:TGadget,tabbar:TGadget
	Field split:TSplitter
	Field debugtree:TDebugTree
	
	Field root:TNode
	Field helproot:TNode
	Field projects:TProjects
	Field coderoot:TNode
	Field navbar:TNavBar	

	Field Mode
	Field debugcode:TOpenCode

	Field quickenable:TGadget,quickenabled	'menu,state
	Field debugenable:TGadget,debugenabled	'menu,state
	Field threadedenable:TGadget,threadedenabled
	Field guienable:TGadget,guienabled		'menu,state
	Field quickhelp:TQuickHelp
	Field running
	Field recentmenu:TGadget
	Field recentfiles:TList=New TList
	Field recentmenus:TGadget[]
	Field openlist:TList=New TList
	Field openlock$
	Field projlist:TList=New TList
	Field winsize:TRect=New TRect
	Field winmax,tooly,splitpos,debugview,navtab
	Field progress,splitorientation

	Field wxbuildmenu:TGadget
	Field wxrunmenu:TGadget
	Field wxBuildAvailable:Int
	Field univenable:TGadget,univenabled	'menu,state
	Field targetmnu:TGadget,targetenabled	'menu,state
	Field targetmacenable:TGadget,targetmacenabled	'menu,state
	Field targetwinenable:TGadget,targetwinenabled	'menu,state
	Field targetlinenable:TGadget,targetlinenabled	'menu,state
	
	Method RanlibMods()
		Local cmd$=Quote( bmxpath+"/bin/bmk" )+" ranlibdir "+Quote( bmxpath+"/mod" )
		system_ cmd
	End Method

	Method CheckVersion$()
		Local	process:TProcess
		Local	bytes:Byte[]
		Local	cmd$,version$

		cmd$=bmxpath+"/bin/bcc"
		
?win32
		cmd:+".exe"
?
		cmd=Quote(cmd)
		process=CreateProcess(cmd$,HIDECONSOLE)
		If process
			While True
				bytes=process.pipe.ReadPipe()
				If bytes
					version:+String.FromBytes(bytes,Len bytes)
				EndIf
				If Not process.status() Exit				
				Delay 10
			Wend
		EndIf

		If version=""
			Notify "Unable to determine BlitzMax version.~n~nPlease reinstall BlitzMax to repair this problem."
			End
		EndIf
		
		BCC_VERSION=version.Trim()
		
'		print "bcc version="+version

		If version.find("(expired)")>-1	'Demo timed out
			Notify "This demo version of BlitzMax has expired.~n~nPlease visit www.blitzbasic.com to buy the full version."
			End
		EndIf

		If version.find("Demo Version")>-1	'Valid demo version
			is_demo=True
?MacOS
			If FileType( bmxpath+"/cfg/ide.ini" )=FILETYPE_NONE RanlibMods
?
			Notify version+"~nTo purchase the full version please visit www.blitzbasic.com."
			Notify ABOUTDEMO
		EndIf
		
	End Method
	
	Method OpenProgress(message$)
'		progress.Open message
		DisableGadget window
		SetStatus message
		progress=-1
	End Method

	Method CloseProgress()
'		progress.Hide
		SetStatus ""
		EnableGadget window
		progress=0
	End Method
	
	Method UpdateProgress(message$,value=0)		'returns false if cancelled
'		Return progress.Update(message,value)
		If progress
			If progress/5<>value/5
				SetStatus message+" "+value+"%"
				progress=value
'				Pollsystem
			EndIf
		EndIf
	End Method

	Method FullPath$(path$)
		If path[..8]="$BMXPATH" path=bmxpath+path[8..]
		path=RealPath(path)
?win32
		path=path.Replace("\","/")
?
		Return path
	End Method

	Method IsTempPath(path$)
		If path[..Len bmxpath+5]=bmxpath+"/tmp/" Return True
	End Method
	
	Method AddDefaultProj(p$)
		Local projdata:TList
		projdata=New TList
		projdata.AddLast p
		projlist.AddLast projdata
	End Method

	Method ReadConfig()
		Local	stream:TStream
		Local	f$,p,a$,b$
' defaults		
		Local wh=GadgetHeight(Desktop())-80'32
		Local ww=wh
		Local wx=(GadgetWidth(Desktop())-ww)/2
		Local wy=(GadgetHeight(Desktop())-wh)/2
		winsize.set( wx,wy,ww,wh )
		quickenabled=False
		debugenabled=True
		threadedenabled=False
		guienabled=True
		
		univenabled=False
		targetenabled=True
		targetmacenabled=False
		targetwinenabled=False
		targetlinenabled=False
?macos
		targetmacenabled=True
?win32
		targetwinenabled=True
?linux
		targetlinenabled=True
?
		
		splitpos=200;splitorientation = SPLIT_VERTICAL
' read ini
		stream=ReadFile(bmxpath+"/cfg/ide.ini")
		If Not stream
			AddDefaultProj "Samples|samples"
			If Not is_demo
				AddDefaultProj "Modules Source|mod"
				AddDefaultProj "BlitzMax Source|src"
			EndIf
			Return
		EndIf
		options.read(stream)		
		options.Snapshot

		Local projdata:TList
		
		While Not stream.Eof()
			f$=stream.ReadLine()
			p=f.find("=")
			If p=-1 Continue
			a$=f[..p]
			b$=f[p+1..]
			Select a$
				Case "ide_version"
				
				Case "file_recent"
					recentfiles.addlast b$
				Case "file_open"
					openlist.addlast b$
				Case "prg_quick"
					quickenabled=Int(b$)
				Case "prg_debug"
					debugenabled=Int(b$)
				Case "prg_threaded"
					threadedenabled=Int(b$)
				Case "prg_gui"
					guienabled=Int(b$)
				Case "prg_univ" ' BaH
					univenabled=Int(b$)
				Case "prg_targmac"
					targetmacenabled=Int(b$)
				Case "prg_targwin"
					targetwinenabled =Int(b$)
				Case "prg_targlin"
					targetlinenabled =Int(b$)
				Case "cmd_line"
					cmdline=b$
				Case "prg_locked"
					openlock=b$
				Case "win_size"
					winsize.FromString(b$)
				Case "win_max"
					winmax=Int(b$)
				Case "split_position"
					splitpos=Int(b$)
				Case "split_orientation"
					splitorientation=Int(b$)
				Case "proj_node"
					projdata=New TList
					projdata.AddLast b
					projlist.AddLast projdata
				Case "proj_data"
					If projdata projdata.AddLast b
				Case "sync_state"
					syncmodsreq.FromString b$
			End Select
		Wend
		stream.close		
	End Method
	
	Method WriteConfig()
		Local	panel:TToolPanel
		Local	stream:TStream
		Local	node:TNode
		Local	f$
		stream=WriteFile(bmxpath+"/cfg/ide.ini")
		If Not stream Return
' options
		options.write(stream)
' defaults		
		stream.WriteLine "[Defaults]"
		stream.WriteLine "ide_version="+IDE_VERSION$
		stream.WriteLine "prg_quick="+quickenabled
		stream.WriteLine "prg_debug="+debugenabled
		stream.WriteLine "prg_threaded="+threadedenabled
		stream.WriteLine "prg_gui="+guienabled
		stream.WriteLine "prg_univ="+univenabled
		stream.WriteLine "prg_targmac="+targetmacenabled
		stream.WriteLine "prg_targwin="+targetwinenabled
		stream.WriteLine "prg_targlin="+targetlinenabled
		stream.WriteLine "win_size="+winsize.ToString()
		stream.WriteLine "win_max="+winmax
		stream.WriteLine "split_position="+SplitterPosition(split)
		stream.WriteLine "split_orientation="+SplitterOrientation(split)
		stream.WriteLine "cmd_line="+cmdline
		stream.WriteLine "sync_state="+syncmodsreq.ToString()
		If lockedpanel stream.WriteLine "prg_locked="+lockedpanel.path
		For f$=EachIn recentfiles
			stream.WriteLine "file_recent="+f$
		Next
		For panel=EachIn panels
			f$=panel.path
			If f$ And Not IsTempPath(f$) stream.WriteLine "file_open="+f$
		Next
		projects.write(stream)	
		stream.close
	End Method
	
	Method CloseAll(dontask,inccurrent=True)	'returns true if successful
		Local	count, cancel
		For Local panel:TToolPanel = EachIn panels
			If TOpenCode(panel) And (inccurrent Or currentpanel <> panel) count:+1
		Next
		If (Not count) Or dontask Or Confirm("MaxIDE needs to close all documents before continuing.")
			For Local panel:TToolPanel = EachIn panels[..]	'Use a copy of the original array for iterating.
				If (inccurrent Or currentpanel <> panel) And panel.invoke(TOOLCLOSE) Then
					cancel=True
					Exit
				EndIf
			Next
			Return Not cancel
		EndIf
	End Method

	Method Quit()
		WriteConfig
		If CloseAll(True) running=False
	End Method

	Method DebugExit()
		If debugcode
			debugtree.cancontinue = False
			debugcode.Edit		'restore cursor etc.	
			debugcode=Null
		EndIf
		SetMode EDITMODE
		RefreshToolbar()
	End Method
		
	Method DebugSource(path$,line,column)
		Local	code:TOpenCode
		path=FullPath(path)
		code=OpenSource(path)
		If code=Null
			Notify("Failed to Open "+path)
			Return
		EndIf
		If debugcode And debugcode<>code debugcode.Edit		'restore cusor etc.	
		debugcode=code
		debugcode.debug(line,column)	
		ActivateWindow window
		PollSystem
	End Method
	
	Method SetMode(m)
		If Mode=m Return
		ActivateWindow window
		Select m
		Case DEBUGMODE
			navtab=navbar.SelectedView()
			navbar.SelectView debugview
		Case EDITMODE
			navbar.SelectView navtab
		End Select
		Mode=m
		RefreshToolbar
	End Method
	
	Method RefreshToolbar()		
		Local	i
' sourceedit buttons
		If THelpPanel(CurrentPanel)
			DisableGadgetItem toolbar,2
		Else
			EnableGadgetItem toolbar,2
		EndIf
		If TOpenCode(CurrentPanel)
			EnableGadgetItem toolbar,3
			For i=5 To 8
				EnableGadgetItem toolbar,i
			Next
		Else
			DisableGadgetItem toolbar,3
			For i=5 To 8
				DisableGadgetItem toolbar,i
			Next			
		EndIf
' debug buttons
		If Mode=DEBUGMODE And debugtree.cancontinue
			For i=12 To 14
				EnableGadgetItem toolbar,i
			Next
		Else
			For i=12 To 14
				DisableGadgetItem toolbar,i
			Next
		EndIf
' stop button		
		If output And output.process
			EnableGadgetItem toolbar,15
		Else
			DisableGadgetItem toolbar,15
		EndIf		
	End Method
	
	Method IsSourceOpen(path$)
		Local	panel:TToolPanel
		Local	p$
		p$=FullPath(path)
		For panel=EachIn panels
			If panel.path=p Return True
		Next
	End Method
	
	Method OpenSource:TOpenCode(path$)
		Local	code:TOpenCode
		Local	panel:TToolPanel
		Local	ext$,p$
		If path$="." 
			path$=RequestFile("Open File",FileTypeFilters )
			If path$="" Return
		EndIf
' check if already open
		p$=FullPath(path).ToLower()
		For panel=EachIn panels
			If panel.path.ToLower()=p
				SelectPanel panel
				Return TOpenCode(panel)
			EndIf
		Next
' open based on extension		
'		Select ExtractExt(Upper(path$))
'		Case "BMX","TXT","BB","CPP","C","S","I","H","HTML","CSS","BAT","FS","VS","README",""
			OpenProgress "Loading "+StripDir(path)
			code=TOpenCode.Create(path,Self)
			If code 
				AddRecent code.path
'				opencoderoot.Append code.GetNode()
'				opencoderoot.Refresh 
'				opencoderoot.Open
			EndIf
			CloseProgress
			If code 
				ActivateGadget code.textarea
				code.GetNode().Refresh
			EndIf
			Return code
'		end select
	End Method
	
	Method AddRecent(path$)
		Local	f$
		For f$=EachIn recentfiles
			If f$=path$ recentfiles.Remove(f$);Exit
		Next
		recentfiles.AddFirst(path$)
		RefreshRecentFiles
		UpdateWindowMenu window
	End Method
	
	Method RefreshRecentFiles()
		Local	n,f$
		Local	m:TGadget
		For m=EachIn recentmenus
			FreeMenu m
		Next
		n=Min(recentfiles.count(),16)
		recentmenus=New TGadget[n]
		n=0
		For f$=EachIn recentfiles
			recentmenus[n]=CreateMenu(f$,MENURECENT+n,recentmenu)
			n:+1
			If n=16 Exit
		Next
	End Method
	
	Method BuildModules(buildall)
		Local cmd$,out$,exe$
		output.Stop
		SaveAll
		cmd$=quote(bmkpath)
		cmd$:+" makemods "
		If buildall cmd$:+"-a "
		If threadedenabled cmd:+"-h "
		If targetmacenabled And univenabled cmd$:+ "-i " ' BaH
		If targetwinenabled cmd$:+ "-l win32 " ' hardcoded for now. Win32 only
		Execute cmd,"Building Modules"
	End Method

	Method ImportBB()
		Local	f$,cmd$,path$
		f$=RequestFile("Import .bb File","bb" )
		If Not f$ Return
		cmd$=quote(bmkpath$)
		cmd$:+" convertbb "
		cmd$:+quote(FullPath(f$))
		Execute cmd,"Converting "+StripExt(StripDir(f$))
		output.wait
		OpenSource(StripExt(f$)+".bmx")
	End Method

	Method GetCommandLine$()
		Return cmdline
	End Method

	Method SetCommandLine(text$)
		cmdline=text
	End Method
	
	Method SetStatus(text$)
		SetStatusText window,text
	End Method

	Method Execute(cmd$,mess$="",post$="",home=True,tool:TTool=Null)
		If Not output output=TOutputPanel.Create(Self)
		output.execute cmd$,mess$,post$,home,tool
	End Method

	Method SelectError(path$,column,line)
		Local	panel:TOpenCode,found
		For panel=EachIn panels
			If panel.path=path found=True;Exit
		Next
		If Not found panel=OpenSource(path)
		If panel
			SelectPanel panel
			panel.Debug line,column
		EndIf
	End Method
	
	Method ParseError(err$)
		Local		mess$,file$,p,q
		Local		line,column
' bcc error
		If err$[..13]="Compile Error"
			err=err[14..]
			p=err.find(EOL$)
			If p=-1 p=Len err
			mess=err[..p]
			err=err[p+1..]
			If err[..1]="["
				p=err.find("]")
				If p=-1 p=Len err
				file$=err[1..p]
				p=file.find(";")+1
				If p=0 p=Len err
				q=file.find(";",p)+1
				If q=0 q=Len err
				line=Int(file[p..q-1])
				column=Int(file[q..])
				file=FullPath(file[..p-1])				
				SelectError file,column,line
			EndIf
			Notify "Compile Error"+EOL+EOL+mess
			SetStatus mess
			Return
		EndIf
' gcc error
		err=err.Replace(EOL+"   "," ")
		While err
			p=err.find(EOL)
			If p=-1 p=(Len err)-1
			mess=err[..p]
			err=err[p+1..]
			p=0
			While True
				p=mess.Find(":",p)+1
				If p=0 Exit
				q=mess.Find(":",p)
				If q<>-1
					file=mess[..p-1]
					line=Int(mess[p..q])
					If line
						mess=mess[q+1..]
						SelectError file,column,line
						Notify "Compile Error"+EOL+EOL+mess
						Return
					EndIf
					p=q+1
				EndIf
			Wend
		Wend		
	End Method
		
	Method AddPanel(tabpanel:TToolPanel)
		Local	panel:TGadget,index
		index=CountGadgetItems(tabbar)
		If panels.length<=index panels=panels[..index+1]
		AddGadgetItem(tabbar,tabpanel.name$,True)
		
		panel=CreatePanel(0,0,ClientWidth(tabbar),ClientHeight(tabbar),tabbar,0)	'name		
		SetGadgetLayout panel,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED
		tabpanel.panel=panel
		
		tabpanel.index=index
		panels[index]=tabpanel
		SelectPanel tabpanel
		AddHandler tabpanel
	End Method

	Method AddHandler(handler:TEventHandler)
		eventhandlers.addlast handler
	End Method

	Method RemovePanel(tabpanel:TToolPanel)
		Local p:TToolPanel[]
		Local index
		eventhandlers.remove tabpanel
' unset debugcode
		If debugcode=tabpanel debugcode=Null
' activate next panel
		If tabpanel=activepanel activepanel=helppanel
		If tabpanel=lockedpanel lockedpanel=Null
		If tabpanel=currentpanel
			index=tabpanel.index+1
			If index>=panels.length index=panels.length-2
			SelectPanel panels[index]
		EndIf
' remove from array
		p=panels
		panels=panels[..panels.length-1]
		For index=tabpanel.index To panels.length-1
			panels[index]=p[index+1]
			panels[index].index=index
		Next
' remove gadget	- simon come here,  placing before remove needs fix in fltk
		FreeGadget tabpanel.panel
		RemoveGadgetItem tabbar,tabpanel.index
		tabpanel.panel=Null
	End Method
		
	Method SetRequester(req:TRequester)
		activerequester=req
	End Method
	
	Method SetTitle(title$="")
		If title title=" - "+title
		SetGadgetText window,"MaxIDE"+title
	End Method
	
	Method SelectPanel(panel:TToolPanel)	
		Local	Current:TToolPanel
		Current=currentpanel
		currentpanel=panel
		If Current And Current<>currentpanel
			SelectGadgetItem tabbar,panel.index
			ShowGadget panel.panel
			If panel.active activepanel=panel
			HideGadget Current.panel
			RefreshToolbar
		EndIf
		currentpanel.Invoke TOOLSHOW
	End Method
		
	Method RefreshPanel(panel:TToolPanel)	'call after a name change
		ModifyGadgetItem( tabbar,panel.index,panel.name )	
	End Method

	Function OutsideDesktop(winrect:TRect)
		Local desk:TGadget,x,y,w,h
		desk=Desktop()
		x=GadgetX(desk)
		y=GadgetY(desk)
		w=GadgetWidth(desk)
		h=GadgetHeight(desk)
		Return winrect.IsOutside(x,y,w,h)
	End Function

	Method SetCodeNode(code:TNode)
		Local node:TNode
		If coderoot.kids.count() node=TNode(coderoot.kids.First())
		If node=code Return
		If node node.Detach
		If code
			coderoot.Append code
			coderoot.Refresh 
			coderoot.Open
			code.Open
		EndIf
	End Method

	Method Initialize()		
		Local	open:TOpenCode, splash:TGadget
		Local	i,dir$,nomods,pname$,p
		Local	stream:TStream
		
		Try
			bmxpath=BlitzMaxPath()
		Catch err$
			Notify "MaxIDE could not find the BlitzMax compiler (bin/bcc).~nPlease reinstall BlitzMax and try again.~n~nAppDir=~q"+AppDir + "~q"
			End
		EndTry
		
		CreateDir BlitzMaxPath()+"/tmp"
		
		bmkpath=bmxpath+"/bin/bmk"
?win32
		bmkpath:+".exe"
?
		dir$=bmxpath+"/mod"
		If FileType(dir)=0
			If Not CreateDir(dir)
				Notify "Failed to Create Module Directory "+dir
				End
			EndIf
			nomods=True
		EndIf
		dir$=bmxpath+"/tmp"
		If FileType(dir)=0
			If Not CreateDir(dir)
				Notify "Failed to Create Temp Directory "+dir
				End
			EndIf
		EndIf
		dir$=bmxpath+"/cfg"
		If FileType(dir)=0
			If Not CreateDir(dir)
				Notify "Failed to Create Config Directory "+dir
				End
			EndIf
		EndIf
		
		CheckVersion
		
		splash=CreateWindow("MaxIDE",200,200,400,140,Null,WINDOW_CLIENTCOORDS|WINDOW_HIDDEN|WINDOW_CENTER)
			Local panel:TGadget = CreatePanel(0,0,ClientWidth(splash),ClientHeight(splash),splash,0)
			SetPanelColor panel,255,255,255;SetPanelPixmap panel, LoadPixmapPNG("incbin::splash.png"), PANELPIXMAP_FIT2
			Local progress:TGadget = CreateProgBar(2,ClientHeight(panel)-22,ClientWidth(panel)-4,20,panel)
			ShowGadget splash;PollSystem
		
		window=CreateWindow("MaxIDE",20,20,760,540,Null,WINDOW_TITLEBAR|WINDOW_RESIZABLE|WINDOW_STATUS|WINDOW_HIDDEN|WINDOW_ACCEPTFILES|WINDOW_MENU)
		
		cmdlinereq=TCmdLineRequester.Create(Self)
		syncmodsreq=TSyncModsRequester.Create(Self)
		gotoreq=TGotoRequester.Create(Self)
		findreq=TFindRequester.Create(Self)
		replacereq=TReplaceRequester.Create(Self)
		options=TOptionsRequester.Create(Self)
'		progress=TProgressRequester.Create(Self)
		projectreq=TProjectRequester.Create(Self)
		projectprops=TProjectProperties.Create(Self)
		searchreq=TSearchRequester.Create(Self)
		
		UpdateProgBar progress, 0.1;PollSystem
		
		ReadConfig
		If OutsideDesktop(winsize)
			winsize.set(20,20,760,540)		
		EndIf	
		
		UpdateProgBar progress, 0.2;PollSystem
		
		SetGadgetShape(window, winsize.x, winsize.y, winsize.w, winsize.h)

		toolbar=CreateToolBar("incbin::icons.PNG",0,0,0,0,window )
		SetToolBarTips toolbar,["New","Open","Close","Save","","Cut","Copy","Paste","Find","","Build","Build And Run","Step","Step In","Step Out","Stop","","Home","Back","Forward"]

		If options.showtoolbar
			tooly=GadgetHeight(toolbar)
		Else
			HideGadget toolbar
			tooly=0
		EndIf

	?MacOS
		client=window
		' cludge for window growing from adding of toolbar
		If Not winmax SetGadgetShape window,winsize.x,winsize.y,winsize.w,winsize.h
	?
		If Not client
			client=CreatePanel(1,tooly,ClientWidth(window)-2,ClientHeight(window)-tooly-1,window,0)
			SetGadgetLayout client,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED
		EndIf
		
		split=CreateSplitter(0,0,ClientWidth(client),ClientHeight(client),client,SPLIT_VERTICAL)
		SetGadgetLayout(split,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED)
		
		tabbar=CreateTabber(0,0,ClientWidth(SplitterPanel(split,SPLITPANEL_MAIN)),ClientHeight(SplitterPanel(split,SPLITPANEL_MAIN)),SplitterPanel(split,SPLITPANEL_MAIN))	'clientwidth(window),clientheight(window)-tooly,window,0)
		SetGadgetLayout(tabbar,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED,EDGE_ALIGNED)
		
		debugtree=TDebugTree.CreateDebugTree(Self)

		root=TNode.CreateNode("Home")
		
		helproot=root.AddNode("Help")
		
		projects=TProjects.CreateProjects(Self)		
		root.Append projects
	
'		opencoderoot=root.AddNode("Open")
		coderoot=TNode.CreateNode("Code")
		coderoot.Open

		navbar=TNavBar.Create(Self,SplitterPanel(split,SPLITPANEL_SIDEPANE))

		navbar.AddView root
		navbar.AddView coderoot
		debugview=navbar.AddView(debugtree)
		navbar.SelectView 0

		helproot.Open
		projects.Open

		AddHandler navbar
	
		SetMode EDITMODE
		
		UpdateProgBar progress, 0.3;PollSystem
			
		quickhelp=TQuickHelp.LoadCommandsTxt(bmxpath)

		helppanel=THelpPanel.Create(Self)
		
		output=TOutputPanel.Create(Self)
		
		activepanel=helppanel
		InitMenu
		InitHotkeys

		RefreshAll
		PollSystem 'allow repaint
		
		UpdateProgBar progress, 0.4;PollSystem 'allow repaint
		
		Local mkdocs
		If FileType( bmxpath+"/docs/html/User Guide/index.html" )<>FILETYPE_FILE
			CreateDir bmxpath+"/docs/html"
			CreateFile bmxpath+"/docs/html/index.html"
			mkdocs=True
		EndIf
		
		helppanel.Home
		
		UpdateProgBar progress, 0.5;PollSystem
		
' scan projects in projlist		
		Local pdata:TList
		For pdata=EachIn projlist
			projects.AddProject pdata
		Next
		
		UpdateProgBar progress, 0.6;PollSystem
		
		Local tmpProgValue# = 0.6
		Local tmpProgStep#
		
'open files from .ini restorelist		
		If options.restoreopenfiles
			If Not openlist.IsEmpty() Then tmpProgStep = (0.3/openlist.Count())
			For Local f$=EachIn openlist
				open=OpenSource(f$)
				If open And f$=openlock open.SetLocked(True) 
				tmpProgValue:+tmpProgStep;UpdateProgBar progress,tmpProgValue
			Next
		EndIf
		
		tmpProgValue = 0.9
		If AppArgs.length > 1 Then tmpProgStep = (0.1/(AppArgs.length-1)) Else tmpProgValue = 1.0
		UpdateProgBar progress,tmpProgValue;PollSystem
		
' open files specified in command line		
		For i=1 To AppArgs.length-1
			open=OpenSource(AppArgs[i])
			tmpProgValue:+tmpProgStep;UpdateProgBar progress,tmpProgValue;PollSystem
		Next
		
		HideGadget splash;FreeGadget splash
		PollSystem
		
		SetSplitterPosition(split,splitpos);SetSplitterOrientation(split,splitorientation)
		
		If winmax MaximizeWindow(window)
		ShowGadget window	
		
		PollSystem
		running=True
		
		CreateTimer(15)
		
		If nomods syncmodsreq.Show	
		
'build docs if not there		
		If mkdocs
			If Confirm( "Documentation not found - Rebuild documentation?" ) And CloseAll( False ) DocMods
		EndIf
		
	End Method
	
	Method DocMods()
		Local cmd$
		cmd$=quote(bmxpath+"/bin/makedocs")
		execute cmd,"Rebuilding documentation...",MENUTRIGGERSYNCDOCS
	End Method
		
	Method SyncDocs()
		helppanel.SyncDocs()
		quickhelp=TQuickHelp.LoadCommandsTxt(bmxpath)
		helppanel.Home
	End Method

	Method InitMenu()
		Local menu:TGadget,file:TGadget,edit:TGadget,program:TGadget,tools:TGadget
		Local help:TGadget,buildoptions:TGadget
		Local buildmods:TGadget,buildallmods:TGadget,syncmods:TGadget,docmods:TGadget

		Local MENUMOD=MODIFIER_COMMAND

		If options.systemkeys
			MENUMOD=MODIFIER_CONTROL
		EndIf

		menu=WindowMenu(window)

		file=CreateMenu("&File",0,menu)
		CreateMenu "&New",MENUNEW,file,KEY_N,MENUMOD
		CreateMenu "&Open...",MENUOPEN,file,KEY_O,MENUMOD
		recentmenu=CreateMenu("Open &Recent",0,file)
		CreateMenu "",0,file
		CreateMenu "&Close Tab",MENUCLOSE,file,KEY_W,MENUMOD
		CreateMenu "Close All Tabs",MENUCLOSEALL,file,KEY_W,MENUMOD|MODIFIER_SHIFT
		CreateMenu "Close Other Tabs",MENUCLOSEOTHERS,file,KEY_W,MENUMOD|MODIFIER_ALT
		CreateMenu "",0,file
		CreateMenu "&Save",MENUSAVE,file,KEY_S,MENUMOD
		CreateMenu "Save &As...",MENUSAVEAS,file,KEY_S,MENUMOD|MODIFIER_SHIFT
		CreateMenu "Save A&ll",MENUSAVEALL,file
		CreateMenu "",0,file

		If options.systemkeys
?MacOS
			CreateMenu "&Next File",MENUNEXT,file,KEY_RIGHT,MENUMOD
			CreateMenu "&Previous File",MENUPREV,file,KEY_LEFT,MENUMOD
?Not MacOS
			CreateMenu "&Next File",MENUNEXT,file,KEY_RIGHT,MODIFIER_ALT
			CreateMenu "&Previous File",MENUPREV,file,KEY_LEFT,MODIFIER_ALT
?
		Else
			CreateMenu "&Next File",MENUNEXT,file,KEY_RIGHT,MENUMOD
			CreateMenu "&Previous File",MENUPREV,file,KEY_LEFT,MENUMOD		
		EndIf
		CreateMenu "",0,file
		CreateMenu "&Import BB Project...",MENUIMPORTBB,file
		CreateMenu "",0,file
		CreateMenu "IDE Options",MENUOPTIONS,file
		CreateMenu "&Project Manager",MENUPROJECTMANAGER,file	
		CreateMenu "",0,file
		CreateMenu "Print",MENUPRINT,file,KEY_P,MENUMOD
?Not MacOS
		CreateMenu "",0,file
		CreateMenu "E&xit",MENUQUIT,file
?
		edit=CreateMenu("&Edit",0,menu)
		CreateMenu "&Undo",MENUUNDO,edit,KEY_Z,MENUMOD
?MacOS
		CreateMenu "&Redo",MENUREDO,edit,KEY_Z,MENUMOD|MODIFIER_SHIFT
?Not MacOS
		CreateMenu "&Redo",MENUREDO,edit,KEY_Y,MENUMOD
?
		CreateMenu "",0,edit
		CreateMenu "Cu&t",MENUCUT,edit,KEY_X,MENUMOD
		CreateMenu "&Copy",MENUCOPY,edit,KEY_C,MENUMOD
		CreateMenu "&Paste",MENUPASTE,edit,KEY_V,MENUMOD
		CreateMenu "",0,edit
		CreateMenu "Select &All",MENUSELECTALL,edit,KEY_A,MENUMOD
		CreateMenu "",0,edit
		CreateMenu "Block Indent",MENUINDENT,edit,KEY_CLOSEBRACKET,MENUMOD
		CreateMenu "Block Outdent",MENUOUTDENT,edit,KEY_OPENBRACKET,MENUMOD
		CreateMenu "",0,edit
		CreateMenu "&Find...",MENUFIND,edit,KEY_F,MENUMOD
?MacOS
		CreateMenu "Find Next",MENUFINDNEXT,edit,KEY_G,MENUMOD
		CreateMenu "&Replace...",MENUREPLACE,edit,KEY_H,MENUMOD
		CreateMenu "&Goto Line...",MENUGOTO,edit,KEY_L,MENUMOD
?Not MacOS
		CreateMenu "Find Next",MENUFINDNEXT,edit,KEY_F3
		CreateMenu "&Replace...",MENUREPLACE,edit,KEY_H,MENUMOD
		CreateMenu "&Goto Line...",MENUGOTO,edit,KEY_G,MENUMOD
?
		CreateMenu "",0,edit
		CreateMenu "Find in F&iles",MENUFINDINFILES,edit,KEY_F,MENUMOD|MODIFIER_SHIFT
		
		program=CreateMenu("&Program",0,menu)
		CreateMenu "&Build",MENUBUILD,program,KEY_B,MENUMOD
		CreateMenu "Build and &Run",MENURUN,program,KEY_R,MENUMOD

?macos	
		wxbuildmenu = CreateMenu("Build wxMax App",MENUBUILD_WX,program,KEY_B,MENUMOD|MODIFIER_SHIFT)
		wxrunmenu = CreateMenu("Build and Run wxMax App",MENURUN_WX,program,KEY_R,MENUMOD|MODIFIER_SHIFT)
?
		
		CreateMenu "Command &Line...",MENUCOMMANDLINE,program
		CreateMenu "",0,program
		CreateMenu "&Step",MENUSTEP,program,KEY_F9
		CreateMenu "Step &In",MENUSTEPIN,program,KEY_F10
		CreateMenu "Step &Out",MENUSTEPOUT,program,KEY_F11
		CreateMenu "&Terminate",MENUSTOP,program
		buildoptions=CreateMenu("Build Options",0,program)
		quickenable=CreateMenu("Quick Build",MENUQUICKENABLED,buildoptions)
		debugenable=CreateMenu("Debug Build",MENUDEBUGENABLED,buildoptions)
		If FileType( BlitzMaxpath()+"/mod/brl.mod/blitz.mod/bdwgc" )=FILETYPE_DIR
			threadedenable=CreateMenu("Threaded Build",MENUTHREADEDENABLED,buildoptions)
		EndIf
		If FileType( BlitzMaxpath()+"/bin/bcc_ppc" )=FILETYPE_FILE' BaH
			univenable=CreateMenu("Universal Build",MENUUNIVERSALENABLED,buildoptions)
		EndIf
		guienable=CreateMenu("Build GUI App",MENUGUIENABLED,buildoptions)
		
		targetmnu=CreateMenu("Target Platform",MENUTARGET,buildoptions)
		targetmacenable=CreateMenu("OS X",MENUTARGETMACENABLED, targetmnu)
		targetwinenable=CreateMenu("Windows",MENUTARGETWINENABLED, targetmnu)
		targetlinenable=CreateMenu("Linux",MENUTARGETLINENABLED, targetmnu)
		
		
		CreateMenu "",0,program
		CreateMenu "&Lock Build File",MENULOCKBUILD,program
		CreateMenu "&Unlock Build File",MENUUNLOCKBUILD,program
		CreateMenu "",0,program
		'syncmods=CreateMenu("&Synchronize Modules...",MENUSYNCMODS,program)
		'CreateMenu "",0,program
		buildmods=CreateMenu("Build &Modules",MENUBUILDMODULES,program,KEY_D,MENUMOD)
		buildallmods=CreateMenu("Rebuild &All Modules",MENUBUILDALLMODULES,program)
		docmods=CreateMenu("&Rebuild Documentation",MENUDOCMODS,program)
		
		help=CreateMenu("&Help",0,menu)
		CreateMenu "&Home",MENUHOME,help
		CreateMenu "&Back",MENUBACK,help
		CreateMenu "&Forward",MENUFORWARD,help
		CreateMenu "&Quick Help",MENUQUICKHELP,help,KEY_F1
		CreateMenu "&About BlitzMax",MENUABOUT,help
		
		If quickenabled CheckMenu quickenable
		If debugenabled CheckMenu debugenable
		If threadedenabled CheckMenu threadedenable
		If guienabled CheckMenu guienable
		
		If univenabled CheckMenu univenable ' BaH
		If targetmacenabled CheckMenu targetmacenable
		If targetwinenabled CheckMenu targetwinenable
		If targetlinenabled CheckMenu targetlinenable
		If Not targetmacenabled
			If univenable Then
				DisableMenu univenable
			End If
		End If

' disable target menu for non-mac for now...
?Win32
		DisableMenu targetmnu
?macos
		If Not FileType( BlitzMaxpath()+"/mod/bah.mod/appstub.mod" )
			DisableMenu wxbuildmenu
			DisableMenu wxrunMenu
		Else
			wxBuildAvailable=True
		EndIf
		DisableMenu targetlinenable ' linux off for Mac
?linux
		DisableMenu targetmacenable ' mac off for linux
?Not win32
		If Not FileType( BlitzMaxpath()+"/bin/bcc.exe" )=FILETYPE_FILE
			DisableMenu targetmnu
		End If
?
		
?Win32		
		Local mingw$=getenv_("MINGW")
		If Not mingw
			DisableMenu buildmods
			DisableMenu buildallmods
		EndIf
?		
		If is_demo
			DisableMenu syncmods
		EndIf
		
		RefreshRecentFiles
		UpdateWindowMenu window
	End Method

	Method RunCode(_b_wx_max:Int = False)
		If Mode=DEBUGMODE And debugtree.cancontinue
			output.go
			Return
		EndIf
		output.Stop
		SaveAll
	
		'	If we want to build and run wxWidgets apps via Brucey's appstub and modified bmk
		If _b_wx_max
			
			If lockedpanel
				lockedpanel.invoke TOOLRUN_WX
			Else
				activepanel.invoke TOOLRUN_WX
			EndIf
		
		Else

		
			If lockedpanel
				lockedpanel.invoke TOOLRUN
			Else
				activepanel.invoke TOOLRUN
			EndIf
		
		EndIf
		
	End Method
	
	Method BuildCode(_b_wx_max:Int = False)
		output.Stop
		SaveAll
		'	If we want to build wxWidgets apps via Brucey's appstub and modified bmk
		If _b_wx_max
			
			If lockedpanel
				lockedpanel.invoke TOOLBUILD_WX
			Else
				activepanel.invoke TOOLBUILD_WX
			EndIf
		
		Else

			If lockedpanel
				lockedpanel.invoke TOOLBUILD
			Else
				activepanel.invoke TOOLBUILD
			EndIf
		EndIf
	End Method
		
		
	Method AddEventHotKey(key,mods,id,data)
		SetHotKeyEvent key,mods,CreateEvent(id,Null,data)
	End Method
		
	Method InitHotkeys()
		AddEventHotKey KEY_F5,MODIFIER_NONE,EVENT_MENUACTION,MENURUN
		AddEventHotKey KEY_F7,MODIFIER_NONE,EVENT_MENUACTION,MENUBUILD
	End Method
		
	Method SaveAll()
		Local	panel:TToolPanel
		For panel=EachIn panels
			panel.invoke TOOLQUICKSAVE						
		Next
	End Method
	
	Method Restart()
		If Confirm("MaxIDE would like to Restart")
			Quit
		EndIf
	End Method
	
	Method RefreshAll()
		Local	panel:TToolPanel		
' hide/show toolbar
		If options.showtoolbar
			If GadgetHidden(toolbar) 
				tooly=GadgetHeight(toolbar)
				ShowGadget toolbar
				SetGadgetShape client,0,tooly,ClientWidth(window),ClientHeight(window)-tooly				
'				SetGadgetShape tabbar,0,tooly,ClientWidth(window),ClientHeight(window)-tooly
			EndIf
		Else
			If Not GadgetHidden(toolbar)
				tooly=0
				HideGadget toolbar
				SetGadgetShape client,0,tooly,ClientWidth(window),ClientHeight(window)-tooly
'				SetGadgetShape tabbar,0,tooly,clientwidth(window),clientheight(window)-tooly
			EndIf
		EndIf
' refresh panels
		For panel=EachIn panels
			panel.invoke TOOLREFRESH						
		Next
' refresh navbar
		navbar.invoke TOOLREFRESH
	End Method

	Method SnapshotWindow()
		If WindowMaximized(window)
			winmax=True
		Else
			If Not WindowMinimized(window)
				winmax=False
				winsize.x=GadgetX(window)
				winsize.y=GadgetY(window)
				winsize.w=GadgetWidth(window)
				winsize.h=GadgetHeight(window)
			EndIf
		EndIf
	End Method
	
	Method OnMenu(menu,extra:Object=Null)
		Local	index
		
		Local	tool:TTool
		
		tool=TTool(extra)
		If tool
			tool.invoke(TOOLMENU,""+menu)
			Return
		EndIf
	
		Select menu
			Case MENUNEW
				OpenSource ""
			Case MENUOPEN
				OpenSource "."
			Case MENUCLOSE
				currentpanel.invoke TOOLCLOSE
			Case MENUCLOSEALL
				CloseAll True
			Case MENUCLOSEOTHERS
				CloseAll True, False
			Case MENUSAVE
				currentpanel.invoke TOOLSAVE						
			Case MENUSAVEAS			
				currentpanel.invoke TOOLSAVEAS						
			Case MENUSAVEALL
				SaveAll
			Case MENUPRINT
				currentpanel.invoke TOOLPRINT						
			Case MENUQUIT
				Quit

			Case MENUGOTO
				gotoreq.Show
			Case MENUFIND
				currentpanel.invoke TOOLFIND
			Case MENUFINDNEXT
				currentpanel.invoke TOOLFINDNEXT
			Case MENUREPLACE
				replacereq.Show

			Case MENUUNDO currentpanel.invoke TOOLUNDO
			Case MENUREDO currentpanel.invoke TOOLREDO

			Case MENUCUT currentpanel.invoke TOOLCUT
			Case MENUCOPY currentpanel.invoke TOOLCOPY
			Case MENUPASTE currentpanel.invoke TOOLPASTE
			Case MENUSELECTALL currentpanel.invoke TOOLSELECTALL
										
			Case MENUBUILD
				BuildCode 
			Case MENURUN 
				RunCode
			Case MENUBUILD_WX
				BuildCode True
			Case MENURUN_WX
				RunCode True

			Case MENUBUILDMODULES
				If CheckDemo() BuildModules False
			Case MENUBUILDALLMODULES
				If CheckDemo() BuildModules True	
			Case MENUSYNCMODS
				If CheckDemo() And CloseAll(False) syncmodsreq.Show
			Case MENUDOCMODS
				If CheckDemo() And CloseAll(False) DocMods
			Case MENUTRIGGERDOCMODS
				DocMods
			Case MENUTRIGGERSYNCDOCS
				SyncDocs
				
			Case MENUSTEP If output output.stepover
			Case MENUSTEPIN If output output.stepin
			Case MENUSTEPOUT If output output.stepout
			Case MENUSTOP If output output.Stop

			Case MENULOCKBUILD
				activepanel.invoke TOOLLOCK
			Case MENUUNLOCKBUILD
				If lockedpanel lockedpanel.invoke TOOLUNLOCK
			
			Case MENUCOMMANDLINE cmdlinereq.Show
			
			Case MENUQUICKENABLED
				If quickenabled
					quickenabled=False
					UncheckMenu quickenable							
				Else
					quickenabled=True
					CheckMenu quickenable
				EndIf
				UpdateWindowMenu window

			Case MENUDEBUGENABLED
				If debugenabled
					debugenabled=False
					UncheckMenu debugenable							
				Else
					debugenabled=True
					CheckMenu debugenable
				EndIf
				UpdateWindowMenu window
				
			Case MENUTHREADEDENABLED
				If threadedenabled
					threadedenabled=False
					UncheckMenu threadedenable							
				Else
					threadedenabled=True
					CheckMenu threadedenable
				EndIf
				UpdateWindowMenu window
				
			Case MENUGUIENABLED
				If guienabled
					guienabled=False
					UncheckMenu guienable							
				Else
					guienabled=True
					CheckMenu guienable
				EndIf
				UpdateWindowMenu window

			Case MENUUNIVERSALENABLED
				If univenabled
					univenabled=False
					UncheckMenu univenable							
				Else
					univenabled=True
					CheckMenu univenable
				EndIf
				UpdateWindowMenu window

			Case MENUTARGETMACENABLED ' BaH
				If Not targetmacenabled
					targetmacenabled=True
					targetwinenabled=False
					targetlinenabled=False
					CheckMenu targetmacenable
					UncheckMenu targetwinenable
?linux
					UncheckMenu targetlinenable
?
					
					If univenable Then
						EnableMenu univenable
					End If
				EndIf
				UpdateWindowMenu window

			Case MENUTARGETWINENABLED ' BaH
				If Not targetwinenabled
					targetmacenabled=False
					targetwinenabled=True
					targetlinenabled=False
?macos
					UncheckMenu targetmacenable
?
					CheckMenu targetwinenable
?linux
					UncheckMenu targetlinenable
?
					If univenable Then
						DisableMenu univenable
					End If
				EndIf
				UpdateWindowMenu window

			Case MENUTARGETLINENABLED ' BaH
				If Not targetlinenabled
					targetmacenabled=False
					targetwinenabled=False
					targetlinenabled=True
?macos
					UncheckMenu targetmacenable
?
					UncheckMenu targetwinenable
					CheckMenu targetlinenable

					If univenable Then
						DisableMenu univenable
					End If
				EndIf
				UpdateWindowMenu window

			Case MENUIMPORTBB
				ImportBB
				
			Case MENUFINDINFILES
				If activepanel Then searchreq.ShowWithPath( ExtractDir(activepanel.path) ) Else searchreq.Show()
				
			Case MENUPROJECTMANAGER
				projectreq.Open projects
			Case MENUSHOWCONSOLE
				If output output.Open

			Case MENUOPTIONS
				options.Show
				
			Case MENUNEXT
				If Not currentpanel Return
				index=currentpanel.index+1
				If index=panels.length index=0
				SelectPanel panels[index]

			Case MENUPREV
				If Not currentpanel Return
				index=currentpanel.index-1
				If index<0 index=panels.length-1
				SelectPanel panels[index]
			
			Case MENUQUICKHELP 
				currentpanel.invoke TOOLHELP
			
			Case MENUHOME
				helppanel.Home
				SelectPanel helppanel
			Case MENUBACK
				helppanel.Back
				SelectPanel helppanel
			Case MENUFORWARD
				helppanel.Forward
				SelectPanel helppanel
			Case MENUABOUT
				Local typ$
				If is_demo typ="Demo" Else typ="Release"
				Local msg$=ABOUT.Replace( "{bcc_version}",BCC_VERSION )
				Notify msg
			Case MENUINDENT
				currentpanel.invoke TOOLINDENT
			Case MENUOUTDENT
				currentpanel.invoke TOOLOUTDENT
				
			Case MENUNEWVIEW
				navbar.invoke TOOLNEWVIEW
				
		End Select
		
		If menu>=MENURECENT
			Local f$=String(recentfiles.ValueAtIndex(menu-MENURECENT))
			If f$ OpenSource f$
		EndIf
	End Method
	
	Method poll()
		Local	handler:TEventHandler
		Local	requester:TRequester
		Local	src:TGadget,file$,event
		Local	index

		event=WaitEvent()
		
		If activerequester
			Select event
				Case EVENT_MENUACTION
					If ActiveGadget() Then 
						Select EventData()
							Case MENUSELECTALL;ActivateGadget(ActiveGadget())
							Case MENUCOPY;GadgetCopy(ActiveGadget())
							Case MENUPASTE;GadgetPaste(ActiveGadget())
							Case MENUCUT;GadgetCut(ActiveGadget())
						EndSelect
					EndIf
				Case EVENT_MOUSEENTER,EVENT_MOUSELEAVE,EVENT_GADGETLOSTFOCUS
					Return
			End Select
'			DebugLog CurrentEvent.ToString()
			activerequester.Poll
			Return
		EndIf

		For handler=EachIn eventhandlers
			handler.OnEvent()
		Next

		Select event
			Case EVENT_GADGETACTION
				Select EventSource()
					Case toolbar
						Select EventData()
							Case 0 OpenSource ""
							Case 1 OpenSource "."
							Case 2 currentpanel.invoke TOOLCLOSE
							Case 3 currentpanel.invoke TOOLSAVE	
							Case 5 currentpanel.invoke TOOLCUT
							Case 6 currentpanel.invoke TOOLCOPY
							Case 7 currentpanel.invoke TOOLPASTE
							Case 8 currentpanel.invoke TOOLFIND
							Case 10 BuildCode
							Case 11 RunCode
							Case 12 If output output.stepover
							Case 13 If output output.stepin
							Case 14 If output output.stepout
							Case 15 If output output.Stop
							Case 17 helppanel.Home;SelectPanel helppanel
							Case 18 helppanel.Back;SelectPanel helppanel
							Case 19 helppanel.Forward;SelectPanel helppanel
							Case 20 BuildCode True
							Case 21 RunCode True
	
						End Select
						
					Case tabbar
						index=EventData()
						If index>=0 And index<panels.length
							SelectPanel panels[index]
						EndIf
				End Select
				
			Case EVENT_WINDOWACCEPT, EVENT_APPOPENFILE
				OpenSource EventText()
				
			Case EVENT_APPTERMINATE
				Quit
				
			Case EVENT_WINDOWACTIVATE
				SelectPanel currentpanel
				
			Case EVENT_WINDOWCLOSE
				src=TGadget(EventSource())
				For requester=EachIn eventhandlers
					If src=requester.window requester.Hide
				Next
				If src=window Quit

			Case EVENT_WINDOWMOVE
				If EventSource()=window SnapshotWindow				
				
			Case EVENT_WINDOWSIZE
				If EventSource()=window 
					SnapshotWindow
				EndIf
			Case EVENT_MENUACTION
				OnMenu EventData(),EventExtra()
			Case EVENT_APPTERMINATE
				OnMenu MENUQUIT

		End Select
	End Method

End Type
